searchData={"items":[{"type":"module","title":"jhn_bencoding","doc":"A Bencoding library based on: The BitTorrent specification Bencoding is represented as follows: Byte string : binary (octets) Integer : integer List : list Dictionary : map","ref":"jhn_bencoding.html"},{"type":"function","title":"jhn_bencoding.decode/1","doc":"Decodes the iodata into a structured Erlang term. Equivalent of decode(JSON, []) -&gt; Term.","ref":"jhn_bencoding.html#decode/1"},{"type":"function","title":"jhn_bencoding.decode/2","doc":"Decodes the iodata into a structured Erlang term. Options are: continue -&gt; return the tuple of the decoded Bencoding and the remaining binary","ref":"jhn_bencoding.html#decode/2"},{"type":"function","title":"jhn_bencoding.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, []) -&gt; Bencoding.","ref":"jhn_bencoding.html#encode/1"},{"type":"function","title":"jhn_bencoding.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: binary -&gt; a binary is returned iolist -&gt; an iolist is returned (default)","ref":"jhn_bencoding.html#encode/2"},{"type":"type","title":"jhn_bencoding.bencoding/0","doc":null,"ref":"jhn_bencoding.html#t:bencoding/0"},{"type":"type","title":"jhn_bencoding.opt/0","doc":null,"ref":"jhn_bencoding.html#t:opt/0"},{"type":"module","title":"jhn_blist","doc":"String Processing Functions for binary encoded strings. This is a drop in replacement for the lists module in stdlib working on binaries interpreted as strings of octets in Latin1. The module generates ref binaries as much as possible so if copies are more suitable apply binary/copy/1 on the result. All functions in the stblib lists that would operate on tuples operate on equally sized octet blobs binaries.","ref":"jhn_blist.html"},{"type":"function","title":"jhn_blist.all/2","doc":"Returns true if Pred(Elem) returns true for all elements Elem in String, otherwise false.","ref":"jhn_blist.html#all/2"},{"type":"function","title":"jhn_blist.any/2","doc":"Returns true if Pred(Elem) returns true for at least one element Elem in String.","ref":"jhn_blist.html#any/2"},{"type":"function","title":"jhn_blist.append/1","doc":"Returns a String in which all the sub-strings of ListOfStrings have been appended.","ref":"jhn_blist.html#append/1"},{"type":"function","title":"jhn_blist.append/2","doc":"Returns a new list String3 which is made from the elements of String1 followed by the elements of String2.","ref":"jhn_blist.html#append/2"},{"type":"function","title":"jhn_blist.concat/1","doc":"Concatenates the text representation of the elements of Things. The elements of Things can be atoms, integers, floats, strings, or binaries.","ref":"jhn_blist.html#concat/1"},{"type":"function","title":"jhn_blist.delete/2","doc":"Returns a copy of String1 where the first element matching Elem is deleted, if there is such an element.","ref":"jhn_blist.html#delete/2"},{"type":"function","title":"jhn_blist.dropwhile/2","doc":"Drops elements Elem from String1 while Pred(Elem) returns true and returns the remaining string.","ref":"jhn_blist.html#dropwhile/2"},{"type":"function","title":"jhn_blist.duplicate/2","doc":"Returns a string which contains N copies of the term Elem.","ref":"jhn_blist.html#duplicate/2"},{"type":"function","title":"jhn_blist.filter/2","doc":"String2 is a string of all elements Elem in String1 for which Pred(Elem) returns true.","ref":"jhn_blist.html#filter/2"},{"type":"function","title":"jhn_blist.flatlength/1","doc":"Equivalent to length(iolist_to_binary(DeepString)), but more efficient.","ref":"jhn_blist.html#flatlength/1"},{"type":"function","title":"jhn_blist.flatmap/2","doc":"Takes a function from As to strings of Bs, and a string of As (String1) and produces a string of Bs by applying the function to every element in String1 and appending the resulting strings.","ref":"jhn_blist.html#flatmap/2"},{"type":"function","title":"jhn_blist.flatten/1","doc":"Returns a flattened version of DeepString.","ref":"jhn_blist.html#flatten/1"},{"type":"function","title":"jhn_blist.flatten/2","doc":"Returns a flattened version of DeepString with the tail Tail appended.","ref":"jhn_blist.html#flatten/2"},{"type":"function","title":"jhn_blist.foldl/3","doc":"Calls Fun(Elem, AccIn) on successive elements A of String, starting with AccIn == Acc0. Fun/2 must return a new accumulator which is passed to the next call. The function returns the final value of the accumulator. Acc0 is returned if the string is empty.","ref":"jhn_blist.html#foldl/3"},{"type":"function","title":"jhn_blist.foldr/3","doc":"Like foldl/3, but the string is traversed from right to left.","ref":"jhn_blist.html#foldr/3"},{"type":"function","title":"jhn_blist.foreach/2","doc":"Calls Fun(Elem) for each element Elem in String. This function is used for its side effects and the evaluation order is defined to be the same as the order of the elements in the string.","ref":"jhn_blist.html#foreach/2"},{"type":"function","title":"jhn_blist.keydelete/4","doc":"Returns a copy of BlobSequence1 where the first occurrence of a blob whose Nth element compares equal to Key is deleted, if there is such a blob.","ref":"jhn_blist.html#keydelete/4"},{"type":"function","title":"jhn_blist.keyfind/4","doc":"Searches the list of tuples BlobSequence for a tuple whose Nth element compares equal to Key. Returns Blob if such a tuple is found, otherwise false.","ref":"jhn_blist.html#keyfind/4"},{"type":"function","title":"jhn_blist.keymap/4","doc":"Returns a sequence of blobs where, for each blob in BlobSequence1, the Nth element Octet of the blob has been replaced with the result of calling Fun(Octet).","ref":"jhn_blist.html#keymap/4"},{"type":"function","title":"jhn_blist.keymember/4","doc":"Returns true if there is a blob in BlobSequence whose Nth element compares equal to Key, otherwise false.","ref":"jhn_blist.html#keymember/4"},{"type":"function","title":"jhn_blist.keymerge/4","doc":"Returns the sorted binary formed by merging BlobSequence1 and BlobSequence2. The merge is performed on the Nth element of each blob. Both BlobSequence1 and BlobSequence2 must be key-sorted prior to evaluating this function. When two blobs compare equal, the blob from BlobSequence1 is picked before the tuple from BlobSequence2.","ref":"jhn_blist.html#keymerge/4"},{"type":"function","title":"jhn_blist.keyreplace/5","doc":"Returns a copy of BlobSequence1 where the first occurrence of a T blob whose Nth element compares equal to Key is replaced with NewBlob, if there is such a blob T.","ref":"jhn_blist.html#keyreplace/5"},{"type":"function","title":"jhn_blist.keysearch/4","doc":"Searches the sequence of blobs BlobSequence for a blob whose Nth element compares equal to Key. Returns {value, Blob} if such a blob is found, otherwise false.","ref":"jhn_blist.html#keysearch/4"},{"type":"function","title":"jhn_blist.keysort/3","doc":"Returns a binary containing the sorted elements of the blob sequence BlobSequence1. Sorting is performed on the Nth element of the blobs. The sort is stable.","ref":"jhn_blist.html#keysort/3"},{"type":"function","title":"jhn_blist.keystore/5","doc":"Returns a copy of BlobSequence1 where the first occurrence of a blob T whose Nth element compares equal to Key is replaced with NewBlob, if there is such a tuple T. If there is no such blob T a copy of BlobSequence1 where NewBlob has been appended to the end is returned.","ref":"jhn_blist.html#keystore/5"},{"type":"function","title":"jhn_blist.keytake/4","doc":"Searches the sequence of blobs BlobSequence1 for a blob whose Nth element compares equal to Key. Returns {value, Blob, BlobSequence2} if such a tuple is found, otherwise false. BlobSequence2 is a copy of BlobSequence1 where the first occurrence of Blob has been removed.","ref":"jhn_blist.html#keytake/4"},{"type":"function","title":"jhn_blist.last/1","doc":"Returns the last octet in the binary.","ref":"jhn_blist.html#last/1"},{"type":"function","title":"jhn_blist.map/2","doc":"Takes a function from octets to octets, and a binary produces binary by applying the function to every octet in the binary. This function is used to obtain the return values. The evaluation order is implementation dependent.","ref":"jhn_blist.html#map/2"},{"type":"function","title":"jhn_blist.mapfoldl/3","doc":"mapfoldl combines the operations of map/2 and foldl/3 into one pass.","ref":"jhn_blist.html#mapfoldl/3"},{"type":"function","title":"jhn_blist.mapfoldr/3","doc":"mapfoldr combines the operations of map/2 and foldr/3 into one pass","ref":"jhn_blist.html#mapfoldr/3"},{"type":"function","title":"jhn_blist.max/1","doc":"Returns the first octet of the binary that compares greater than or equal to all other octets in the binary.","ref":"jhn_blist.html#max/1"},{"type":"function","title":"jhn_blist.member/2","doc":"Returns true if Elem matches some element of Binary, otherwise false.","ref":"jhn_blist.html#member/2"},{"type":"function","title":"jhn_blist.merge3/3","doc":"Returns the sorted binary formed by merging Binary1, Binary2 and Binary3. All of Binary1, Binary2 and Binary3 must be sorted prior to evaluating this function. When two octets compare equal, the octet from Binary1, if there is such an octet, is picked before the other octet, otherwise the octet from Binary2 is picked before the octet from Binary3.","ref":"jhn_blist.html#merge3/3"},{"type":"function","title":"jhn_blist.merge/1","doc":"Returns the sorted binary formed by merging all the sub-binaries of ListOfBinaries. All sub-binaries must be sorted prior to evaluating this function. When two octets compare equal, the octets from the sub-binary with the lowest position in ListOfBinaries is picked before the other octet.","ref":"jhn_blist.html#merge/1"},{"type":"function","title":"jhn_blist.merge/2","doc":"Returns the sorted binary formed by merging Binary1 and Binary2. Both Binary1 and Binary2 must be sorted prior to evaluating this function. When two octets compare equal, the octet from Binary1 is picked before the octet from Binary2.","ref":"jhn_blist.html#merge/2"},{"type":"function","title":"jhn_blist.merge/3","doc":"Returns the sorted binary formed by merging Binary1 and Binary2. Both Binary1 and Binary2 must be sorted according to the ordering function Fun prior to evaluating this function. Fun(A, B) should return true if A compares less than or equal to B in the ordering, false otherwise. When two octets compare equal, the octet from Binary1 is picked before the octet from Binary2.","ref":"jhn_blist.html#merge/3"},{"type":"function","title":"jhn_blist.min/1","doc":"Returns the first octet of Binary that compares less than or equal to all other octets of Binary.","ref":"jhn_blist.html#min/1"},{"type":"function","title":"jhn_blist.nth/2","doc":"Returns the Nth octet of Binary. One based.","ref":"jhn_blist.html#nth/2"},{"type":"function","title":"jhn_blist.nthtail/2","doc":"Returns the Nth tail of Binary, that is, the sub-binary of Binary starting at N+1 and continuing up to the end of the binary.","ref":"jhn_blist.html#nthtail/2"},{"type":"function","title":"jhn_blist.partition/2","doc":"Partitions Binary into two binaries, where the first binary contains all octets for which Pred(Octet) returns true, and the second binary contains all octets for which Pred(Octet) returns false.","ref":"jhn_blist.html#partition/2"},{"type":"function","title":"jhn_blist.prefix/2","doc":"Returns true if Binary1 is a prefix of Binary2, otherwise false.","ref":"jhn_blist.html#prefix/2"},{"type":"function","title":"jhn_blist.reverse/1","doc":"Returns a string with the elements in String1 in reverse order.","ref":"jhn_blist.html#reverse/1"},{"type":"function","title":"jhn_blist.reverse/2","doc":"Returns a string with the elements in String1 in reverse order, with the tail Tail appended.","ref":"jhn_blist.html#reverse/2"},{"type":"function","title":"jhn_blist.seq/2","doc":"Returns a sequence of integers which starts with From and contains the successive results of adding 1 to the previous element, until To has been reached number encompassed by the sequence. Wraps to zero when it reaches 255.","ref":"jhn_blist.html#seq/2"},{"type":"function","title":"jhn_blist.seq/3","doc":"Returns a sequence of integers which starts with From and contains the successive results of adding Incr to the previous element, until To has been reached or passed (in the latter case, To is not an element of the sequence). Wraps to zero when it reaches 255.","ref":"jhn_blist.html#seq/3"},{"type":"function","title":"jhn_blist.sort/1","doc":"Returns a binary containing the sorted octets of Binary1.","ref":"jhn_blist.html#sort/1"},{"type":"function","title":"jhn_blist.sort/2","doc":"Returns a binary containing the sorted octets of Binary1, according to the ordering function Fun. Fun(A, B) should return true if A compares less than or equal to B in the ordering, false otherwise.","ref":"jhn_blist.html#sort/2"},{"type":"function","title":"jhn_blist.split/2","doc":"Splits Binary1 into Binary2 and Binary3. Binary2 contains the first N octets and Binary3 the rest of the octets (the Nth tail).","ref":"jhn_blist.html#split/2"},{"type":"function","title":"jhn_blist.splitwith/2","doc":"Partitions Binary into two binaries according to Pred. splitwith/2 behaves as if it is defined as follows: splitwith(Pred, Binary) -&gt; {takewhile(Pred, Binary), dropwhile(Pred, Binary)}.","ref":"jhn_blist.html#splitwith/2"},{"type":"function","title":"jhn_blist.sublist/2","doc":"Returns the sub-binary of Binary1 starting at position 1 and with (max) Len octets. It is not an error for Len to exceed the length of the binary, in that case the whole binary is returned.","ref":"jhn_blist.html#sublist/2"},{"type":"function","title":"jhn_blist.sublist/3","doc":"Returns the sub-binary of Binary1 starting at Start and with (max) Len octets. It is not an error for Start+Len to exceed the length of the binary.","ref":"jhn_blist.html#sublist/3"},{"type":"function","title":"jhn_blist.subtract/2","doc":"Returns a new binary Binary3 which is a copy of Binary1, subjected to the following procedure: for each octet in Binary2, its first occurrence in Binary1 is deleted.","ref":"jhn_blist.html#subtract/2"},{"type":"function","title":"jhn_blist.suffix/2","doc":"Returns true if Binary1 is a suffix of Binary2, otherwise false.","ref":"jhn_blist.html#suffix/2"},{"type":"function","title":"jhn_blist.sum/1","doc":"Returns the sum of the octets in binary.","ref":"jhn_blist.html#sum/1"},{"type":"function","title":"jhn_blist.takewhile/2","doc":"Takes octet Octet from Binary1 while Pred(Octet) returns true, that is, the function returns the longest prefix of the binary for which all octets satisfy the predicate.","ref":"jhn_blist.html#takewhile/2"},{"type":"function","title":"jhn_blist.ukeymerge/4","doc":"Returns the sorted binary formed by merging BlobSequence1 and BlobSequence2. The merge is performed on the Nth octet of each blob. Both BlobSequence1 and BlobSequence2 must be key-sorted without duplicates prior to evaluating this function. When two blobs compare equal, the blob from BlobSequence1 is picked and the one from BlobSequence2 deleted.","ref":"jhn_blist.html#ukeymerge/4"},{"type":"function","title":"jhn_blist.ukeysort/3","doc":"Returns a binary containing the sorted octets of the binary BlobSequence1 where all but the first blob of the blobs comparing equal have been deleted. Sorting is performed on the Nth element of the blobs.","ref":"jhn_blist.html#ukeysort/3"},{"type":"function","title":"jhn_blist.umerge3/3","doc":"Returns the sorted binary formed by merging Binary1, Binary2 and Binary3. All of Binary1, Binary2 and Binary3 must be sorted and contain no duplicates prior to evaluating this function. When two octets compare equal, the octet from Binary1 is picked if there is such an octet, otherwise the octet from Binary2 is picked, and the other one deleted.","ref":"jhn_blist.html#umerge3/3"},{"type":"function","title":"jhn_blist.umerge/1","doc":"Returns the sorted binary formed by merging all the sub-binaries of ListOfBinaries. All sub-binaries must be sorted and contain no duplicates prior to evaluating this function. When two elements compare equal, the element from the sub-binaries with the lowest position in ListOfBinaries is picked and the other one deleted.","ref":"jhn_blist.html#umerge/1"},{"type":"function","title":"jhn_blist.umerge/2","doc":"Returns the sorted binary formed by merging Binary1 and Binary2. Both Binary1 and Binary2 must be sorted and contain no duplicates prior to evaluating this function. When two octets compare equal, the octet from Binary1 is picked and the one from Binary2 deleted.","ref":"jhn_blist.html#umerge/2"},{"type":"function","title":"jhn_blist.umerge/3","doc":"Returns the sorted binary formed by merging Binary1 and Binary2. Both Binary1 and Binary2 must be sorted according to the ordering function Fun and contain no duplicates prior to evaluating this function. Fun(A, B) should return true if A compares less than or equal to B in the ordering, false otherwise. When two octets compare equal, the octet from Binary1 is picked and the one from Binary2 deleted.","ref":"jhn_blist.html#umerge/3"},{"type":"function","title":"jhn_blist.unzip3/1","doc":"&quot;Unzips&quot; a binary of three octet blobs into three binarys, where the first binary contains the first octet of each blob, the second binary contains the second octet of each blob, and the third binary contains the third octet of each blob.","ref":"jhn_blist.html#unzip3/1"},{"type":"function","title":"jhn_blist.unzip/1","doc":"&quot;Unzips&quot; a binary of two octet blobs into two binarys, where the first binary contains the first octet of each blob, and the second binary contains the second octet of each blob.","ref":"jhn_blist.html#unzip/1"},{"type":"function","title":"jhn_blist.usort/1","doc":"Returns a binary containing the sorted octets of Binary1 where all but the first octet of the octets comparing equal have been deleted.","ref":"jhn_blist.html#usort/1"},{"type":"function","title":"jhn_blist.usort/2","doc":"Returns a binary which contains the sorted octets of Binary1 where all but the first octet of the octets comparing equal according to the ordering function Fun have been deleted. Fun(A, B) should return true if A compares less than or equal to B in the ordering, false otherwise.","ref":"jhn_blist.html#usort/2"},{"type":"function","title":"jhn_blist.zip3/3","doc":"&quot;Zips&quot; three binaries of equal length into one binary of three-blobs, where the first octet of each blob is taken from the first binary, the second octet is taken from corresponding octet in the second binary, and the third octet is taken from the corresponding octet in the third binary.","ref":"jhn_blist.html#zip3/3"},{"type":"function","title":"jhn_blist.zip/2","doc":"&quot;Zips&quot; two binaries of equal length into one binary of two-blobs, where the first octet of each blob is taken from the first binary and the second octet is taken from corresponding octet in the second binary.","ref":"jhn_blist.html#zip/2"},{"type":"function","title":"jhn_blist.zipwith3/4","doc":"Combine the octets of three binarys of equal length into one binary. For each triple X, Y, Z of binary octets from the thre binarys, the binary in the result binary will be Combine(X, Y, Z). zipwith(fun(X, Y, Z) -&gt; &lt;&lt;X, Y, Z&gt;&gt; end, Binary1, Binary2, Binary3) is equivalent to zip(Binary1, Binary2. Binary3).","ref":"jhn_blist.html#zipwith3/4"},{"type":"function","title":"jhn_blist.zipwith/3","doc":"Combine the octets of two binarys of equal length into one binary. For each pair X, Y of binary octets from the two binarys, the binary in the result binary will be Combine(X, Y). zipwith(fun(X, Y) -&gt; &lt;&lt;X, Y&gt;&gt; end, Binary1, Binary2) is equivalent to zip(Binary1, Binary2).","ref":"jhn_blist.html#zipwith/3"},{"type":"type","title":"jhn_blist.thing/0","doc":null,"ref":"jhn_blist.html#t:thing/0"},{"type":"module","title":"jhn_bloom","doc":"Implements Bloom filters Based on: Scalable Bloom Filters by Paulo Sérgio Almeida, Carlos Baquero, Nuno Preguiça, David Hutchison","ref":"jhn_bloom.html"},{"type":"function","title":"jhn_bloom.add/2","doc":"Adds a term to the Bloom filter","ref":"jhn_bloom.html#add/2"},{"type":"function","title":"jhn_bloom.capacity/1","doc":"Returns the capacity of the Bloom filter","ref":"jhn_bloom.html#capacity/1"},{"type":"function","title":"jhn_bloom.filter/0","doc":"Returns a bloom filter","ref":"jhn_bloom.html#filter/0"},{"type":"function","title":"jhn_bloom.filter/1","doc":"Returns a bloom filter Options are: fixed -&gt; standard partitioned bloom filter, default type scalable -&gt; scalable bloom filter size -&gt; the maximum size for fixed and initial size for scalable filter the defaults are 4000 and 32000 respectively error_prob -&gt; error probability, default 0.001 Options relevant to scalable filters only growth_ratio -&gt; log 2 of growth ratio, one of 1, 2, 3 default 1 error_ratio -&gt; error probability ratio, default 0.85","ref":"jhn_bloom.html#filter/1"},{"type":"function","title":"jhn_bloom.is_filter/1","doc":"Returns true if the argument is a Bloom filter","ref":"jhn_bloom.html#is_filter/1"},{"type":"function","title":"jhn_bloom.member/2","doc":"Returns if the term is a member of the Bloom filter","ref":"jhn_bloom.html#member/2"},{"type":"function","title":"jhn_bloom.type/1","doc":"Returns the type of Bloom filter","ref":"jhn_bloom.html#type/1"},{"type":"opaque","title":"jhn_bloom.filter/0","doc":null,"ref":"jhn_bloom.html#t:filter/0"},{"type":"type","title":"jhn_bloom.opt/0","doc":null,"ref":"jhn_bloom.html#t:opt/0"},{"type":"module","title":"jhn_bstring","doc":"String Processing Functions for binary encoded strings. This is a drop in replacement for the string module in stdlib working on binaries interpreted as strings of octets in Latin1. The module generates ref binaries as much as possible so if copies are more suitable apply binary/copy/1 on the result. Functions affected are the sub string family and tokens/2.","ref":"jhn_bstring.html"},{"type":"function","title":"jhn_bstring.centre/2","doc":"Returns a string, where String is centred in the string and surrounded by blanks. The resulting string will have the length Number.","ref":"jhn_bstring.html#centre/2"},{"type":"function","title":"jhn_bstring.centre/3","doc":"Returns a string, where String is centred in the string and surrounded by characters. The resulting string will have the length Number.","ref":"jhn_bstring.html#centre/3"},{"type":"function","title":"jhn_bstring.chars/2","doc":"Returns a string consisting of Number of characters Character.","ref":"jhn_bstring.html#chars/2"},{"type":"function","title":"jhn_bstring.chars/3","doc":"Returns a string consisting of Number of characters Character, the string ends with the string Tail.","ref":"jhn_bstring.html#chars/3"},{"type":"function","title":"jhn_bstring.chr/2","doc":"Returns the index of the first occurrence of Character in String. 0 is returned if Character does not occur.","ref":"jhn_bstring.html#chr/2"},{"type":"function","title":"jhn_bstring.concat/2","doc":"Concatenates two strings to form a new string. Returns the new string.","ref":"jhn_bstring.html#concat/2"},{"type":"function","title":"jhn_bstring.copies/2","doc":"Returns a string containing String repeated Number times.","ref":"jhn_bstring.html#copies/2"},{"type":"function","title":"jhn_bstring.cspan/2","doc":"Returns the length of the maximum initial segment of String, which consists entirely of characters not from Chars.","ref":"jhn_bstring.html#cspan/2"},{"type":"function","title":"jhn_bstring.equal/2","doc":"Tests whether two strings are equal. Returns true if they are, otherwise false.","ref":"jhn_bstring.html#equal/2"},{"type":"function","title":"jhn_bstring.join/2","doc":"Returns a string with the elements of StringList separated by the string in Separator.","ref":"jhn_bstring.html#join/2"},{"type":"function","title":"jhn_bstring.left/2","doc":"Returns the String with the length adjusted in accordance with Number. The left margin is fixed. If the length(String) &lt; Number , String is padded with blanks.","ref":"jhn_bstring.html#left/2"},{"type":"function","title":"jhn_bstring.left/3","doc":"Returns the String with the length adjusted in accordance with Number. The left margin is fixed. If the length(String) &lt; Number , String is padded with Characters.","ref":"jhn_bstring.html#left/3"},{"type":"function","title":"jhn_bstring.len/1","doc":"Returns the number of characters in the string.","ref":"jhn_bstring.html#len/1"},{"type":"function","title":"jhn_bstring.rchr/2","doc":"Returns the index of the last occurrence of Character in String. 0 is returned if Character does not occur.","ref":"jhn_bstring.html#rchr/2"},{"type":"function","title":"jhn_bstring.right/2","doc":"Returns the String with the length adjusted in accordance with Number. The right margin is fixed. If the length of (String) &lt; Number , String is padded with blanks.","ref":"jhn_bstring.html#right/2"},{"type":"function","title":"jhn_bstring.right/3","doc":"Returns the String with the length adjusted in accordance with Number. The right margin is fixed. If the length of (String) &lt; Number , String is padded with Characters.","ref":"jhn_bstring.html#right/3"},{"type":"function","title":"jhn_bstring.rstr/2","doc":"Returns the position where the last occurrence of SubString begins in String. 0 is returned if SubString does not exist in String.","ref":"jhn_bstring.html#rstr/2"},{"type":"function","title":"jhn_bstring.span/2","doc":"Returns the length of the maximum initial segment of String, which consists entirely of characters from Chars.","ref":"jhn_bstring.html#span/2"},{"type":"function","title":"jhn_bstring.str/2","doc":"Returns the position where the first occurrence of SubString begins in String. 0 is returned if SubString does not exist in String.","ref":"jhn_bstring.html#str/2"},{"type":"function","title":"jhn_bstring.strip/1","doc":"Returns a string, where leading and trailing blanks have been removed. The function strip/1 is equivalent to strip(String, both).","ref":"jhn_bstring.html#strip/1"},{"type":"function","title":"jhn_bstring.strip/2","doc":"Returns a string, where leading and/or trailing blanks have been removed. Direction can be left, right, or both and indicates from which direction blanks are to be removed.","ref":"jhn_bstring.html#strip/2"},{"type":"function","title":"jhn_bstring.strip/3","doc":"Returns a string, where leading and/or trailing blanks or a number of Character have been removed. Direction can be left, right, or both and indicates from which direction blanks are to be removed.","ref":"jhn_bstring.html#strip/3"},{"type":"function","title":"jhn_bstring.sub_string/2","doc":"Returns a substring of String, starting at the position Start to the end of the string.","ref":"jhn_bstring.html#sub_string/2"},{"type":"function","title":"jhn_bstring.sub_string/3","doc":"Returns a substring of String, starting at the position Start to the end of the string, or to and including the Stop position.","ref":"jhn_bstring.html#sub_string/3"},{"type":"function","title":"jhn_bstring.sub_word/2","doc":"Returns the word in position Number of String. Words are separated by blanks .","ref":"jhn_bstring.html#sub_word/2"},{"type":"function","title":"jhn_bstring.sub_word/3","doc":"Returns the word in position Number of String. Words are separated by Characters.","ref":"jhn_bstring.html#sub_word/3"},{"type":"function","title":"jhn_bstring.substr/2","doc":"Returns a substring of String, starting at the position Start, and ending at the end of the string.","ref":"jhn_bstring.html#substr/2"},{"type":"function","title":"jhn_bstring.substr/3","doc":"Returns a substring of String, starting at the position Start, and ending at the end of the string or at length Length.","ref":"jhn_bstring.html#substr/3"},{"type":"function","title":"jhn_bstring.to_float/1","doc":"Argument String is expected to start with a valid text represented float (the digits being ASCII values). Remaining characters in the string after the float are returned in Rest.","ref":"jhn_bstring.html#to_float/1"},{"type":"function","title":"jhn_bstring.to_integer/1","doc":"Argument String is expected to start with a valid text represented integer (the digits being ASCII values). Remaining characters in the string after the integer are returned in Rest.","ref":"jhn_bstring.html#to_integer/1"},{"type":"function","title":"jhn_bstring.to_lower/1","doc":"The given string is case-converted. Note that the supported character set is ISO/IEC 8859-1 (a.k.a. Latin 1), all values outside this set is unchanged.","ref":"jhn_bstring.html#to_lower/1"},{"type":"function","title":"jhn_bstring.to_upper/1","doc":"The given string is case-converted. Note that the supported character set is ISO/IEC 8859-1 (a.k.a. Latin 1), all values outside this set is unchanged.","ref":"jhn_bstring.html#to_upper/1"},{"type":"function","title":"jhn_bstring.tokens/2","doc":"Returns a list of tokens in String, separated by the characters in Separators.","ref":"jhn_bstring.html#tokens/2"},{"type":"function","title":"jhn_bstring.words/1","doc":"Returns the number of words in String, separated by blanks.","ref":"jhn_bstring.html#words/1"},{"type":"function","title":"jhn_bstring.words/2","doc":"Returns the number of words in String, separated by Character.","ref":"jhn_bstring.html#words/2"},{"type":"type","title":"jhn_bstring.direction/0","doc":null,"ref":"jhn_bstring.html#t:direction/0"},{"type":"module","title":"jhn_cbor","doc":"A CBOR library based on: Concise Binary Object Representation (CBOR) (rfc8949) IANA Considerations and IETF Protocol and Documentation Usage for IEEE 802 Parameters (rfc9542) Supported tags: rfc8949: 0, 1, 2, 3, 4, 5, 24, 32, 33, 34, 55799 rfc9542: 48 Tags unlikely to ever be supported: 21, 22, 23 CBOR cbor() values are represented as follows: Simple values: False(20) : false True(21) : true Null(22) : null Undefined(23) : undefined (Integer) : {simple, integer()} Numbers: Integer : integer() Float : float() | {float16, float()} | {float32, float()} | {float64, float()} | inf | neg_inf | nan. Bistrings: String : {string, binary()} indefinite length String : {strings, [{string, binary()}]} Text : binary() indefinite length Texts : {texts, [binary()]} Collections: Map : #{cbor() =&gt; cbor()} indefinite length Map : {map, [#{cbor() =&gt; cbor()}]} Array : [cbor()] Arrays : {arrays, [cbor()]} Tags: timestamp(0) : {tag, timestamp, integer() | binary()} posix(1) : {tag, posix, integer() | float() | null | undefined} bignum(2) : {tag, bignum, non_neg_integer()} bignum(3) : {tag, bignum, neg_integer()} decimal_fraction(4) : {tag, decimal_fraction, {integer(), integer()}} bigfloat(5) : {tag, bigfloat, {integer(), integer()} embedded(24) : {tag, embedded, binary()} uri(32) : {tag, uri, #uri{} | binary()} base64url(33) : {tag, base64url, binary()} base64(34) : {tag, based, binary()} mac(48) : {tag, mac, binary()} cbor(55799) : {tag, cbor, cbor()} (Integer) : {tag, integer(), _}","ref":"jhn_cbor.html"},{"type":"function","title":"jhn_cbor.decode/1","doc":"Decodes the binary into a tuple of structured Erlang term.","ref":"jhn_cbor.html#decode/1"},{"type":"function","title":"jhn_cbor.decode/2","doc":"Decodes the binary into a structured Erlang term or a tuple of a structured Erlang term and the rest of the binary if the continue option is given. A {tag_callbacks, [{integer(), nodule()}]} can supplied to specify a module with a cbor_decode_tag callback function to decode tags not supporrted in this module.","ref":"jhn_cbor.html#decode/2"},{"type":"function","title":"jhn_cbor.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, []) -&gt; CBOR.","ref":"jhn_cbor.html#encode/1"},{"type":"function","title":"jhn_cbor.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: binary -&gt; a binary is returned iolist -&gt; an iolist is returned (default) {tag_callbacks, [{integer(), nodule()}]} specifies a module with a cbor_encode_tag callback function to decode tags not supporrted in this module.","ref":"jhn_cbor.html#encode/2"},{"type":"type","title":"jhn_cbor.array/0","doc":null,"ref":"jhn_cbor.html#t:array/0"},{"type":"type","title":"jhn_cbor.cbor/0","doc":null,"ref":"jhn_cbor.html#t:cbor/0"},{"type":"type","title":"jhn_cbor.cfloat/0","doc":null,"ref":"jhn_cbor.html#t:cfloat/0"},{"type":"type","title":"jhn_cbor.cmap/0","doc":null,"ref":"jhn_cbor.html#t:cmap/0"},{"type":"type","title":"jhn_cbor.cstring/0","doc":null,"ref":"jhn_cbor.html#t:cstring/0"},{"type":"type","title":"jhn_cbor.ctext/0","doc":null,"ref":"jhn_cbor.html#t:ctext/0"},{"type":"type","title":"jhn_cbor.opt/0","doc":null,"ref":"jhn_cbor.html#t:opt/0"},{"type":"type","title":"jhn_cbor.opts/0","doc":null,"ref":"jhn_cbor.html#t:opts/0"},{"type":"type","title":"jhn_cbor.simple/0","doc":null,"ref":"jhn_cbor.html#t:simple/0"},{"type":"type","title":"jhn_cbor.tag/0","doc":null,"ref":"jhn_cbor.html#t:tag/0"},{"type":"type","title":"jhn_cbor.tag_alias/0","doc":null,"ref":"jhn_cbor.html#t:tag_alias/0"},{"type":"type","title":"jhn_cbor.tag_content/0","doc":null,"ref":"jhn_cbor.html#t:tag_content/0"},{"type":"module","title":"jhn_chash","doc":"Consistent hashing Jump consistent hashing based on: A Fast, Minimal Memory, Consistent Hash Algorithm by John Lamping and Eric Veach","ref":"jhn_chash.html"},{"type":"function","title":"jhn_chash.jump/2","doc":"Given a integer key and the number of buckets it select a bucket.","ref":"jhn_chash.html#jump/2"},{"type":"behaviour","title":"jhn_fsm","doc":"This is a generic FSM in the spirit of OTP's gen_fsm but subtly different. A generic server process (jhn_fsm) implemented using this module has a standard set of interface functions. It also fits into an OTP supervision tree and supports generic OTP tooling for, e.g., dynamic upgrades. The FSM can defer acting on incoming events messages to a later state, the defered events/messages are processed when a state-transition happen. The order of deferred events/messages are preserved. En event/messages is only deferred when a callback function returns deferred. A jhn_fsm process assumes all specific parts to be located in a callback module exporting a predefined set of functions, some optional. The relationship between the behavior functions and the callback functions is as follows: -----&gt;/-----&gt; fuction call/return ====&gt; message sent User module jhn_fsm module Callback module ----------------------------------------------------------------------- jhn_fsm:create/1/2 -----&gt; proc_lib:spawn -----&gt; init/1 jhn_fsm:create/1/2 &lt;----- proc_lib:spawn &lt;==== init/1 ----------------------------------------------------------------------- jhn_fsm:call/2/3 =====&gt; (jhn_fsm) -----&gt; StateName/2 or event/3 jhn_fsm:call/2/3 &lt;===== (jhn_fsm) &lt;----- jhn_fsm:reply/1/2 (optional) ----------------------------------------------------------------------- jhn_fsm:sync/1/2 =====&gt; (jhn_fsm) jhn_fsm:sync/1/2 &lt;===== (jhn_fsm) ----------------------------------------------------------------------- jhn_fsm:cast/2/3 =====&gt; (jhn_server) -----&gt; StateName/2 or event/3 All the following are optional Other process Callback module ----------------------------------------------------------------------- Id ! Message =====&gt; message/3 sys:terminate/2 =====&gt; terminate/3 sys:code_change/4 =====&gt; code_change/4 sys:get_status/2 =====&gt; format_status/2 If a callback function fails or returns a bad value, the jhn_fsm process terminates. N.B. that a gen_fsm process does not trap exit signals automatically, this must be explicitly initiated in the callback module. The process is by default linked to the parent. The event callback function is called when the state function for the does not have a matching clause for the incoming event, sent either by a call or cast, or the state function is undefined. jhn_fsm supports hibernation. Any call, cast or plain message sent to the process that has not a matching clause in the appropriate StateName/2 event/3or messsage/2 call back function will be discarded and logged as unexpected. If the optional callback funtion message/2 is not defined there are no matching function clauses at all. N.B. Recieving an event/message that is deferred will break hibernation, this may change in the future. The callback module shall export: init(Args) ==&gt; {ok, StateName, State} | {hibernate, StateName, State} | ignore | {error, stop} | {stop, Reason} | The callback module can export: StateName(Msg, State) ==&gt; {ok, StateName, State} | {hibernate, StateName, State} | deferred | {stop, Reason} message(Msg, StateName, State) ==&gt; {ok, StateName, State} | {hibernate, StateName, State} | deferred | {stop, Reason} event(Msg, StateName, State) ==&gt; {ok, StateName, State} | {hibernate, StateName, State} | deferred | {stop, Reason} terminate(Reason, StateName, State) ==&gt; Return value ignored Lets the user module clean up always called when server terminates code_change(OldVsn, StateName, Data, Extra) ==&gt; {ok, State} format_status(Opt, _) ==&gt; {ok, State} Uses the old format will be replaced. !","ref":"jhn_fsm.html"},{"type":"function","title":"jhn_fsm.call/2","doc":"A call is made to FSM with default timeout 5000ms.","ref":"jhn_fsm.html#call/2"},{"type":"function","title":"jhn_fsm.call/3","doc":"A call is made to FSM with Timeout. Will generate a timeout exception if the FSM takes more than Timeout time to answer. Generates an exception if the process is dead, dies, or no process registered under that name. If the FSM returns that is returned from the call.","ref":"jhn_fsm.html#call/3"},{"type":"function","title":"jhn_fsm.cancel/1","doc":"A timer a timer started using delayed_event/2, returns time remaining or false.","ref":"jhn_fsm.html#cancel/1"},{"type":"function","title":"jhn_fsm.cast/2","doc":"An event is sent to the FSM, always retuns ok.","ref":"jhn_fsm.html#cast/2"},{"type":"callback","title":"jhn_fsm.code_change/4","doc":null,"ref":"jhn_fsm.html#c:code_change/4"},{"type":"function","title":"jhn_fsm.create/1","doc":"Creates a jhn_fsm.","ref":"jhn_fsm.html#create/1"},{"type":"function","title":"jhn_fsm.create/2","doc":"Creates a jhn_fsm with options. Options are: {link, Boolean} -&gt; if the fsm is linked to the parent, default true {timeout, infinity | Integer} -&gt; Time in ms for the fsm to create and initialise, after that an exception is generated, default 5000. {name, Atom} -&gt; name that the fsm is registered under. {arg, Term} -&gt; argument provided to the init/1 callback function, default is 'no_arg'.","ref":"jhn_fsm.html#create/2"},{"type":"function","title":"jhn_fsm.delayed_cast/2","doc":"An event is sent to the calling FSM after Delay ms, always returns a timer reference that can be canceled using cancel/1.","ref":"jhn_fsm.html#delayed_cast/2"},{"type":"callback","title":"jhn_fsm.event/3","doc":null,"ref":"jhn_fsm.html#c:event/3"},{"type":"callback","title":"jhn_fsm.format_status/2","doc":null,"ref":"jhn_fsm.html#c:format_status/2"},{"type":"function","title":"jhn_fsm.from/0","doc":"Called inside a state function or event/3 callback function it will provide an opaque data data enables a reply to the call outside the scope of the callback function.","ref":"jhn_fsm.html#from/0"},{"type":"callback","title":"jhn_fsm.init/1","doc":null,"ref":"jhn_fsm.html#c:init/1"},{"type":"callback","title":"jhn_fsm.message/3","doc":null,"ref":"jhn_fsm.html#c:message/3"},{"type":"function","title":"jhn_fsm.reply/1","doc":"Called inside callback function to provide reply to a call.","ref":"jhn_fsm.html#reply/1"},{"type":"function","title":"jhn_fsm.reply/2","doc":"Called by any process will send a reply to the one that sent the event to the fsm, the From argument is the result from a call to from/1 inside a state function or event/3 callback function.","ref":"jhn_fsm.html#reply/2"},{"type":"function","title":"jhn_fsm.sync/1","doc":"A synchronization is made with FSM with default timeout 5000ms.","ref":"jhn_fsm.html#sync/1"},{"type":"function","title":"jhn_fsm.sync/2","doc":"A synchronization is made with FSM with Timeout. Will generate a timeout exception if the FSM takes more than Timeout time to answer. Generates an exception if the process is dead, dies, or no process registered under that name. If the fsm returns, ok is returned.","ref":"jhn_fsm.html#sync/2"},{"type":"callback","title":"jhn_fsm.terminate/3","doc":null,"ref":"jhn_fsm.html#c:terminate/3"},{"type":"function","title":"jhn_fsm.type/0","doc":"Called inside a state function or event/2 and it tells if it is a call or a cast.","ref":"jhn_fsm.html#type/0"},{"type":"type","title":"jhn_fsm.event/0","doc":null,"ref":"jhn_fsm.html#t:event/0"},{"type":"type","title":"jhn_fsm.from/0","doc":null,"ref":"jhn_fsm.html#t:from/0"},{"type":"type","title":"jhn_fsm.fsm_ref/0","doc":null,"ref":"jhn_fsm.html#t:fsm_ref/0"},{"type":"type","title":"jhn_fsm.init_return/1","doc":null,"ref":"jhn_fsm.html#t:init_return/1"},{"type":"type","title":"jhn_fsm.opt/0","doc":null,"ref":"jhn_fsm.html#t:opt/0"},{"type":"type","title":"jhn_fsm.opts/0","doc":null,"ref":"jhn_fsm.html#t:opts/0"},{"type":"type","title":"jhn_fsm.return/1","doc":null,"ref":"jhn_fsm.html#t:return/1"},{"type":"module","title":"jhn_hash","doc":"A few checksum algorithms, CRC32-C and xxHash-32.","ref":"jhn_hash.html"},{"type":"function","title":"jhn_hash.crc32c/1","doc":"Generate a CRC32-C checksum from iodata.","ref":"jhn_hash.html#crc32c/1"},{"type":"function","title":"jhn_hash.xxh32/1","doc":"Generate a xxH32 checksum from iodata with Seed 0.","ref":"jhn_hash.html#xxh32/1"},{"type":"function","title":"jhn_hash.xxh32/2","doc":"Generate a xxH32 checksum from iodata using Seed.","ref":"jhn_hash.html#xxh32/2"},{"type":"module","title":"jhn_ip_addr","doc":"A IP library based on: IP Version 6 Addressing Architecture (rfc4291) A Recommendation for IPv6 Address Text Representation (rfc5952) Classless Inter-domain Routing (CIDR): (rfc4632) The Internet Address Assignment and Aggregation Plan","ref":"jhn_ip_addr.html"},{"type":"function","title":"jhn_ip_addr.bounds/1","doc":"Determines the IP bounds for a range Equivalent of bounds(IOData, []).","ref":"jhn_ip_addr.html#bounds/1"},{"type":"function","title":"jhn_ip_addr.bounds/2","doc":"Determines the IP bounds for a range Bounds will give an exception if the binary is not well formed IP. Options are: integer -&gt; an integer is returned (Default) tuple -&gt; a tuple of integers is returned ipv6ipv4 -&gt; with tuple the two last parts are returned as an IPv4 tuple","ref":"jhn_ip_addr.html#bounds/2"},{"type":"function","title":"jhn_ip_addr.decode/1","doc":"Decodes the binary into an Integer. Equivalent of decode(IOData, []) -&gt; Integer.","ref":"jhn_ip_addr.html#decode/1"},{"type":"function","title":"jhn_ip_addr.decode/2","doc":"Decodes the binary into a structured Erlang. Decode will give an exception if the binary is not well formed IP. Options are: integer -&gt; an integer is returned (Default) tuple -&gt; a tuple of integers is returned ipv6ipv4 -&gt; with tuple the two last parts are returned as an IPv4 tuple range -&gt; a IP range is being decoded continue -&gt; all remaining indata is returned","ref":"jhn_ip_addr.html#decode/2"},{"type":"function","title":"jhn_ip_addr.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, []) -&gt; IP.","ref":"jhn_ip_addr.html#encode/1"},{"type":"function","title":"jhn_ip_addr.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: binary -&gt; a binary is returned list -&gt; a flat list is returned iolist -&gt; an iolist is returned (Default) ipv4 -&gt; an ipv4 address is encoded when the Term is an integer ipv6 -&gt; an ipv6 address is encoded when the Term is an integer ipv6ipv4 -&gt; encoded IPv6 host address has the two least sigificant segments repesented in IPv4 address format compact -&gt; the most compact encoding of IPv6 used (collapsed zeros)","ref":"jhn_ip_addr.html#encode/2"},{"type":"type","title":"jhn_ip_addr.ip/0","doc":null,"ref":"jhn_ip_addr.html#t:ip/0"},{"type":"type","title":"jhn_ip_addr.ipv4/0","doc":null,"ref":"jhn_ip_addr.html#t:ipv4/0"},{"type":"type","title":"jhn_ip_addr.ipv6/0","doc":null,"ref":"jhn_ip_addr.html#t:ipv6/0"},{"type":"type","title":"jhn_ip_addr.opt/0","doc":null,"ref":"jhn_ip_addr.html#t:opt/0"},{"type":"type","title":"jhn_ip_addr.range/0","doc":null,"ref":"jhn_ip_addr.html#t:range/0"},{"type":"module","title":"jhn_json","doc":"A JSON stream library based on: The JavaScript Object Notation (JSON) Data Interchange Format (rfc8259) JavaScript Object Notation (JSON) Pointer (rfc6901) JavaScript Object Notation (JSON) Patch (rfc6902) JSON Merge Patch (rfc7396) JSON is represented as follows: value : true | false | null | object | array | number | string pointer : top | [integer | string | '-'] patch : [object] merge : object object : map array : [value] string : UTF-8 binary number : integer() | float() true : atom(true) false : atom(false) null : atom(null) Strings can be represented by atoms when generating JSON, but will not not be generated when converting JSON to erlang or any of the functions returning JSON. When converting Erlang terms to JSON iolists are generated but it can generate a binary if so instructed. Objects as maps, multiple occurrences of the members is not supported.","ref":"jhn_json.html"},{"type":"function","title":"jhn_json.decode/1","doc":"Decodes the binary if a JSON Pointer into the Erlang respresentation and if a JSON value into a structured Erlang term and the remaining binary is ignored.","ref":"jhn_json.html#decode/1"},{"type":"function","title":"jhn_json.decode/2","doc":"Supports the decoding of when supplied with the the option stream as the option with no options works as decode/1. Decoding a stream of JSON the functions returns either a tuple of a complete json value and the remainder of the stream (binary) or {more, Continuation} where subsequent calls to decode/2 is made with futher data and the Continuation as the second argument. Options are: stream -&gt; enables the decoding of a stream of JSON values.","ref":"jhn_json.html#decode/2"},{"type":"function","title":"jhn_json.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, iolist) -&gt; JSON.","ref":"jhn_json.html#encode/1"},{"type":"function","title":"jhn_json.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will raise an exception if the erlang term is not well formed. Options are: pointer -&gt; the term represents a pointer binary -&gt; a binary is returned iolist -&gt; an iolist is returned (default)","ref":"jhn_json.html#encode/2"},{"type":"function","title":"jhn_json.eval/2","doc":"Selects and decodes a Fragment of a JSON document based on the Pointer. Both the pointer and the JSON can be either a binary or the Erlang representation. If the JSON is a binary and not the complete JSON fragment eval/2 returns {more, Continuation} and eval is called again with Continuation and more of the stream as eval(Continuation, Binary).","ref":"jhn_json.html#eval/2"},{"type":"function","title":"jhn_json.eval/3","doc":"Selects and decodes a Fragment of a JSON document based on the Pointer. Both the pointer and the JSON can be either a binary or the Erlang representation. If the JSON is a binary and not the complete JSON fragment eval/3 returns {more, Continuation} and eval is called again with Continuation and more of the stream as eval(Continuation, Binary).","ref":"jhn_json.html#eval/3"},{"type":"function","title":"jhn_json.merge/2","doc":"Merge applies a JSON Merge Patch to the JSON represented as Erlang returning a new JSON object represented as Erlang.","ref":"jhn_json.html#merge/2"},{"type":"function","title":"jhn_json.next/1","doc":"Picks the first json on a stream and returns that and the rest or {more, Continuation} where Continuation is used in a call to decode(Binary, Continuation).","ref":"jhn_json.html#next/1"},{"type":"function","title":"jhn_json.next/2","doc":"Picks the first json on a stream given a continuation and returns that and the rest or {more Continuation} is if it was not a complete value.","ref":"jhn_json.html#next/2"},{"type":"function","title":"jhn_json.patch/2","doc":"Patch applies the JSON Patch to a JSON value represented as Erlang returning the patched JSON or error if one of the test operations in the JSON Patch failed.","ref":"jhn_json.html#patch/2"},{"type":"type","title":"jhn_json.acc/0","doc":null,"ref":"jhn_json.html#t:acc/0"},{"type":"type","title":"jhn_json.array/0","doc":null,"ref":"jhn_json.html#t:array/0"},{"type":"type","title":"jhn_json.complete/0","doc":null,"ref":"jhn_json.html#t:complete/0"},{"type":"type","title":"jhn_json.cont/0","doc":null,"ref":"jhn_json.html#t:cont/0"},{"type":"type","title":"jhn_json.eval_cont/0","doc":null,"ref":"jhn_json.html#t:eval_cont/0"},{"type":"type","title":"jhn_json.expect/0","doc":null,"ref":"jhn_json.html#t:expect/0"},{"type":"type","title":"jhn_json.first/0","doc":null,"ref":"jhn_json.html#t:first/0"},{"type":"type","title":"jhn_json.json/0","doc":null,"ref":"jhn_json.html#t:json/0"},{"type":"type","title":"jhn_json.jstring/0","doc":null,"ref":"jhn_json.html#t:jstring/0"},{"type":"type","title":"jhn_json.merge/0","doc":null,"ref":"jhn_json.html#t:merge/0"},{"type":"type","title":"jhn_json.name/0","doc":null,"ref":"jhn_json.html#t:name/0"},{"type":"type","title":"jhn_json.next_cont/0","doc":null,"ref":"jhn_json.html#t:next_cont/0"},{"type":"type","title":"jhn_json.object/0","doc":null,"ref":"jhn_json.html#t:object/0"},{"type":"type","title":"jhn_json.opt/0","doc":null,"ref":"jhn_json.html#t:opt/0"},{"type":"type","title":"jhn_json.opts/0","doc":null,"ref":"jhn_json.html#t:opts/0"},{"type":"type","title":"jhn_json.patch/0","doc":null,"ref":"jhn_json.html#t:patch/0"},{"type":"type","title":"jhn_json.path/0","doc":null,"ref":"jhn_json.html#t:path/0"},{"type":"type","title":"jhn_json.phase/0","doc":null,"ref":"jhn_json.html#t:phase/0"},{"type":"type","title":"jhn_json.pointer/0","doc":null,"ref":"jhn_json.html#t:pointer/0"},{"type":"type","title":"jhn_json.skip_cont/0","doc":null,"ref":"jhn_json.html#t:skip_cont/0"},{"type":"type","title":"jhn_json.stack/0","doc":null,"ref":"jhn_json.html#t:stack/0"},{"type":"type","title":"jhn_json.stage/0","doc":null,"ref":"jhn_json.html#t:stage/0"},{"type":"type","title":"jhn_json.stream/0","doc":null,"ref":"jhn_json.html#t:stream/0"},{"type":"type","title":"jhn_json.unwind_cont/0","doc":null,"ref":"jhn_json.html#t:unwind_cont/0"},{"type":"module","title":"jhn_lazy","doc":"A lazy lib. This library provides a simple pull oriented interface towards different data sources using a lazy data abstraction. The primary use case is the decoding of protocols where the sizes of parts are not known until they have been completely decoded and one wishes to decouple the handling of the data source and the protocol code. The user of the library provides a promise of data: a function that given a timeout returns either a data or eol (end of lazy) within the timespan given by the timeout. A promise can also have a state in which case the initial state has to be provided with the function. The stateful promise function must retun a tuple of {Data, NewState}. If the timeout is eol is given the promise should return eol and any resources, such as streams and sockets, should be deallocated. The library provides the functions create/1 and create/2 to create lazy data structures given a promise. The structure can then be applied to a timeout to generate a tuple of data and new lazy data {Data, Lazy} or eol. Several utility functions are provided to construct new LazyData. One function is provided that creates an &quot;empty&quot; LazyData empty/0. Two functions to add a data to existing lazy data are provided: prepend/2 and append/2 that adds the data before or after the lazy data respectively. One function that combines lazy data is provided: concat/2. A number of utility funtions are provided, functioning both as simple examples as well as convenience for basic uses: list_to_data/1, iolist_to_data/1 tcp_to_data/2, tcp_to_data/3,tcp_to_data/4, tcp_socket_to_data/1 tcp_reconnect_to_data/3 file_to_data/2, file_stream_to_data/2 N.B. This library relies heavily on the construction of lambda functions and for the sake of clearity and efficiency should be avoided if a more direct approach, that does not suffer heavily from these very drawback itself, exists.","ref":"jhn_lazy.html"},{"type":"function","title":"jhn_lazy.append/2","doc":"Lazy data is constructed from data and lazy data where when cosumed the data comes after all of the lazy data.","ref":"jhn_lazy.html#append/2"},{"type":"function","title":"jhn_lazy.concat/2","doc":"Lazy data is constructed from lazy data and lazy data where when cosumed the LazyData1 comes before all the data of of the LazyData2.","ref":"jhn_lazy.html#concat/2"},{"type":"function","title":"jhn_lazy.create/1","doc":"Given a promise, lazy data is created.","ref":"jhn_lazy.html#create/1"},{"type":"function","title":"jhn_lazy.create/2","doc":"Given a promise and an initial state, stateful lazy data is created.","ref":"jhn_lazy.html#create/2"},{"type":"function","title":"jhn_lazy.empty/0","doc":"Creates an empty LazyData that just returns eol.","ref":"jhn_lazy.html#empty/0"},{"type":"function","title":"jhn_lazy.file_stream_to_data/2","doc":"A Lazy binary is constructed from the stream, it is expected to be opened in binary raw mode with read_ahead. On errors reading from the stream results in the closure and eol is returned. The mode determines if the data is read linewise or in chunks of Mode characters.","ref":"jhn_lazy.html#file_stream_to_data/2"},{"type":"function","title":"jhn_lazy.file_to_data/2","doc":"A Lazy binary is constructed from the stream, when opening the file in binary raw mode with read_ahead. On errors reading from the stream results in the closure and eol is returned. The mode determines if the data is read linewise or in chunks of Mode characters.","ref":"jhn_lazy.html#file_to_data/2"},{"type":"function","title":"jhn_lazy.iolist_to_data/1","doc":"A Lazy binary is constructed from an iolist.","ref":"jhn_lazy.html#iolist_to_data/1"},{"type":"function","title":"jhn_lazy.list_to_data/1","doc":"Lazy data is constructed from a list.","ref":"jhn_lazy.html#list_to_data/1"},{"type":"function","title":"jhn_lazy.prepend/2","doc":"Lazy data is constructed from data and lazy data where when cosumed the data comes before any of the lazy data.","ref":"jhn_lazy.html#prepend/2"},{"type":"function","title":"jhn_lazy.tcp_reconnect_to_data/3","doc":"A Lazy binary is constructed from the socket that opening a tcp connetion to the host in binary mode with packet size 0. If an error occurs during connection an error is returned. If the connection is closed it is reconnected.","ref":"jhn_lazy.html#tcp_reconnect_to_data/3"},{"type":"function","title":"jhn_lazy.tcp_socket_to_data/1","doc":"A Lazy binary is constructed from the socket, it is expected to be connected to the host in binary mode with packet size 0. On errors/closure reading from the socket results in the closure and eol is returned. Timeout in reading gives an empty binary.","ref":"jhn_lazy.html#tcp_socket_to_data/1"},{"type":"function","title":"jhn_lazy.tcp_to_data/2","doc":"A Lazy binary is constructed from the socket that opening a tcp connetion to the host in binary mode with packet size 0. If an error occurs during connection an error is returned.","ref":"jhn_lazy.html#tcp_to_data/2"},{"type":"function","title":"jhn_lazy.tcp_to_data/3","doc":"A Lazy binary is constructed from the socket that opening a tcp connetion to the host in binary mode with packet size 0. If an error or timeout occurs during connection an error is returned.","ref":"jhn_lazy.html#tcp_to_data/3"},{"type":"function","title":"jhn_lazy.tcp_to_data/4","doc":"A Lazy binary is constructed from the socket that opening a tcp connetion to the host in binary mode with packet size 0. If an error or timeout occurs during connection an error is returned. If the options provided are inconsistent with: {packet, 0}, binary, {active, false} unexpected and undefined behaviour will be the result.","ref":"jhn_lazy.html#tcp_to_data/4"},{"type":"type","title":"jhn_lazy.data/1","doc":null,"ref":"jhn_lazy.html#t:data/1"},{"type":"type","title":"jhn_lazy.promise/1","doc":null,"ref":"jhn_lazy.html#t:promise/1"},{"type":"type","title":"jhn_lazy.promise/2","doc":null,"ref":"jhn_lazy.html#t:promise/2"},{"type":"module","title":"jhn_math","doc":"Misc math functionality.","ref":"jhn_math.html"},{"type":"function","title":"jhn_math.levenshtein/2","doc":"Computes the Levenshtein distance between String1 and String2.","ref":"jhn_math.html#levenshtein/2"},{"type":"function","title":"jhn_math.rotl32/2","doc":"Performs a Steps many left rotation on a 32 bit integer.","ref":"jhn_math.html#rotl32/2"},{"type":"function","title":"jhn_math.rotr32/2","doc":"Performs a Steps many right rotation on a 32 bit integer.","ref":"jhn_math.html#rotr32/2"},{"type":"module","title":"jhn_msgpack","doc":"A MessagePack to and from erlang terms library based on http://wiki.msgpack.org/display/MSGPACK/Format+specification. MessagePack is represented as follows: msgpack : map | array | integers | floats | boolean | raw map : #{msgpack =&gt; msgpack} array : [msgpack*] integers : integer | {pos_fixnum, integer} | {neg_fixnum, integer} | {uint8, integer} | {uint16, integer} | {uint32, integer} | {uint64, integer} | {int8, integer} | {int16, integer} | {int632, integer} | {int64, integer} floats : float | {'float', float} | {'double', float} nil : nil boolean : 'true' | 'false' raw : binary","ref":"jhn_msgpack.html"},{"type":"function","title":"jhn_msgpack.decode/1","doc":"Decodes the binary into a structured Erlang term. Equivalent of decode(MSGPACK, []) -&gt; Term.","ref":"jhn_msgpack.html#decode/1"},{"type":"function","title":"jhn_msgpack.decode/2","doc":"Decodes the binary into a structured Erlang. Decode will give an exception if the binary is not well formed MSGPACK. Options are: number_types -&gt; decode into {Type, Value} for number types.","ref":"jhn_msgpack.html#decode/2"},{"type":"function","title":"jhn_msgpack.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, []) -&gt; MSGPACK.","ref":"jhn_msgpack.html#encode/1"},{"type":"function","title":"jhn_msgpack.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: binary -&gt; a binary is returned iolist -&gt; a iolist is returned","ref":"jhn_msgpack.html#encode/2"},{"type":"type","title":"jhn_msgpack.float_type/0","doc":null,"ref":"jhn_msgpack.html#t:float_type/0"},{"type":"type","title":"jhn_msgpack.floats/0","doc":null,"ref":"jhn_msgpack.html#t:floats/0"},{"type":"type","title":"jhn_msgpack.integer_type/0","doc":null,"ref":"jhn_msgpack.html#t:integer_type/0"},{"type":"type","title":"jhn_msgpack.integers/0","doc":null,"ref":"jhn_msgpack.html#t:integers/0"},{"type":"type","title":"jhn_msgpack.msgpack/0","doc":null,"ref":"jhn_msgpack.html#t:msgpack/0"},{"type":"type","title":"jhn_msgpack.msgpack_array/0","doc":null,"ref":"jhn_msgpack.html#t:msgpack_array/0"},{"type":"type","title":"jhn_msgpack.msgpack_map/0","doc":null,"ref":"jhn_msgpack.html#t:msgpack_map/0"},{"type":"type","title":"jhn_msgpack.opt/0","doc":null,"ref":"jhn_msgpack.html#t:opt/0"},{"type":"type","title":"jhn_msgpack.raw/0","doc":null,"ref":"jhn_msgpack.html#t:raw/0"},{"type":"module","title":"jhn_mustache","doc":"Mustache template rendering. The context is given either as a property list or a map with the keys being the tags as atoms. The partials are realised by recursively call rendering until no tags remain.","ref":"jhn_mustache.html"},{"type":"function","title":"jhn_mustache.render/2","doc":"Renders a mustache template, the same as render(Template, Context, iolist).","ref":"jhn_mustache.html#render/2"},{"type":"function","title":"jhn_mustache.render/3","doc":"Renders a mustache template. Option is: binary -&gt; a binary is returned iolist -&gt; an iolist is returned (default)","ref":"jhn_mustache.html#render/3"},{"type":"type","title":"jhn_mustache.context/0","doc":null,"ref":"jhn_mustache.html#t:context/0"},{"type":"type","title":"jhn_mustache.option/0","doc":null,"ref":"jhn_mustache.html#t:option/0"},{"type":"type","title":"jhn_mustache.template/0","doc":null,"ref":"jhn_mustache.html#t:template/0"},{"type":"module","title":"jhn_p_tree","doc":"Implements Prefix trees that allows you to find a value associated with the longest prefix of the key used. All keys are lists of terms.","ref":"jhn_p_tree.html"},{"type":"function","title":"jhn_p_tree.add/3","doc":"The Value is saved in Tree under the Key, if that key is present the value associated with the key is replaced by Value. add(Key, Value, Tree) is equivalent to add(Key, Value, Tree,nocheck).","ref":"jhn_p_tree.html#add/3"},{"type":"function","title":"jhn_p_tree.add/4","doc":"The Value is saved in Tree under the Key, if that key is present the value associated with the key is replaced by Value. If the flag is check an exception is generated and if nocheck the value is replaced.","ref":"jhn_p_tree.html#add/4"},{"type":"function","title":"jhn_p_tree.adds/2","doc":null,"ref":"jhn_p_tree.html#adds/2"},{"type":"function","title":"jhn_p_tree.adds/3","doc":"For each {Key, Value} pair in Pairs the value is stored under the key in the Tree. If an key already has a value associated with in the Tree the flag determines what happens. If the flag is check an exception is generated if a key has a value associated with it, if the flag is nocheck the values will be replaced.","ref":"jhn_p_tree.html#adds/3"},{"type":"function","title":"jhn_p_tree.delete/2","doc":"If a value is associated the Key the Tree returned has that association removed. The call delete(Key, Tree) is equivalent to delete(Key, Tree, nocheck).","ref":"jhn_p_tree.html#delete/2"},{"type":"function","title":"jhn_p_tree.delete/3","doc":"If a value is associated the Key the Tree returned has that association removed. If there is no value associated with the Key in the Tree the flag determines what happens. If the flag is check an exception is generated if no association exists, if the flag is nocheck the unchanged tree is returned.","ref":"jhn_p_tree.html#delete/3"},{"type":"function","title":"jhn_p_tree.deletes/2","doc":"A tree that has all the associations for the keys removed. The call deletes(Indces, Tree) is equivalent to deletes(Keys, Tree, nocheck).","ref":"jhn_p_tree.html#deletes/2"},{"type":"function","title":"jhn_p_tree.deletes/3","doc":"A tree that has all the associations for the keys removed. If there is no value associated with any of the Keys in the Tree, the flag determines what happens. If the flag is check an exception is generated if, if the flag is nocheck a tree is returned with the other associations removed.","ref":"jhn_p_tree.html#deletes/3"},{"type":"function","title":"jhn_p_tree.find/2","doc":"Returns the value associated with the longest prefix of the Key in the Tree or undefined if no such association exists. The call find(Key, Tree) is equivalent to find(Key, Tree, undefined).","ref":"jhn_p_tree.html#find/2"},{"type":"function","title":"jhn_p_tree.find/3","doc":"Returns the value associated with the longest prefix of the Key in the Tree or Default if no such association exists.","ref":"jhn_p_tree.html#find/3"},{"type":"function","title":"jhn_p_tree.from_list/1","doc":"For each {Key, Value} pair in Pairs the value is stored under the key in the Tree.","ref":"jhn_p_tree.html#from_list/1"},{"type":"function","title":"jhn_p_tree.is_empty/1","doc":"Returns true if the Tree is empty, false otherwise.","ref":"jhn_p_tree.html#is_empty/1"},{"type":"function","title":"jhn_p_tree.is_p_tree/1","doc":"Returns true if X is a P-tree, false otherwise.","ref":"jhn_p_tree.html#is_p_tree/1"},{"type":"function","title":"jhn_p_tree.keys/1","doc":"Returns all the keys in ascending order.","ref":"jhn_p_tree.html#keys/1"},{"type":"function","title":"jhn_p_tree.member/2","doc":"Returns true if there is a value associated with Key in the tree, otherwise false.","ref":"jhn_p_tree.html#member/2"},{"type":"function","title":"jhn_p_tree.new/0","doc":"Creates an empty P-tree.","ref":"jhn_p_tree.html#new/0"},{"type":"function","title":"jhn_p_tree.replace/3","doc":"Replaces any existing value associated with Key in the tree, otherwise adds a association for the value with the Key. The call replace(Key, Value, Tree) is equivalent to replace(Key, Value, Tree, nocheck).","ref":"jhn_p_tree.html#replace/3"},{"type":"function","title":"jhn_p_tree.replace/4","doc":"Replaces any existing value associated with Key in the tree, otherwise the flag determines what happens. If the flag is check an exception is generated, otherwise the value is added.","ref":"jhn_p_tree.html#replace/4"},{"type":"function","title":"jhn_p_tree.to_list/1","doc":"From a P-tree a list of {Key, Value} pairs.","ref":"jhn_p_tree.html#to_list/1"},{"type":"function","title":"jhn_p_tree.values/1","doc":"Returns all the values in ascending order of their keys.","ref":"jhn_p_tree.html#values/1"},{"type":"type","title":"jhn_p_tree.default/0","doc":null,"ref":"jhn_p_tree.html#t:default/0"},{"type":"type","title":"jhn_p_tree.flag/0","doc":null,"ref":"jhn_p_tree.html#t:flag/0"},{"type":"type","title":"jhn_p_tree.key/0","doc":null,"ref":"jhn_p_tree.html#t:key/0"},{"type":"opaque","title":"jhn_p_tree.p_tree/0","doc":null,"ref":"jhn_p_tree.html#t:p_tree/0"},{"type":"type","title":"jhn_p_tree.value/0","doc":null,"ref":"jhn_p_tree.html#t:value/0"},{"type":"module","title":"jhn_pb_tree","doc":"Implements Prefix trees that allows you to find a value associated with the longest prefix of the key used. All keys are utf8 binaries.","ref":"jhn_pb_tree.html"},{"type":"function","title":"jhn_pb_tree.add/3","doc":"The Value is saved in Tree under the Key, if that key is present the value associated with the key is replaced by Value. add(Key, Value, Tree) is equivalent to add(Key, Value, Tree,nocheck).","ref":"jhn_pb_tree.html#add/3"},{"type":"function","title":"jhn_pb_tree.add/4","doc":"The Value is saved in Tree under the Key, if that key is present the value associated with the key is replaced by Value. If the flag is check an exception is generated and if nocheck the value is replaced.","ref":"jhn_pb_tree.html#add/4"},{"type":"function","title":"jhn_pb_tree.adds/2","doc":null,"ref":"jhn_pb_tree.html#adds/2"},{"type":"function","title":"jhn_pb_tree.adds/3","doc":"For each {Key, Value} pair in Pairs the value is stored under the key in the Tree. If an key already has a value associated with in the Tree the flag determines what happens. If the flag is check an exception is generated if a key has a value associated with it, if the flag is nocheck the values will be replaced.","ref":"jhn_pb_tree.html#adds/3"},{"type":"function","title":"jhn_pb_tree.delete/2","doc":"If a value is associated the Key the Tree returned has that association removed. The call delete(Key, Tree) is equivalent to delete(Key, Tree, nocheck).","ref":"jhn_pb_tree.html#delete/2"},{"type":"function","title":"jhn_pb_tree.delete/3","doc":"If a value is associated the Key the Tree returned has that association removed. If there is no value associated with the Key in the Tree the flag determines what happens. If the flag is check an exception is generated if no association exists, if the flag is nocheck the unchanged tree is returned.","ref":"jhn_pb_tree.html#delete/3"},{"type":"function","title":"jhn_pb_tree.deletes/2","doc":"A tree that has all the associations for the keys removed. The call deletes(Indces, Tree) is equivalent to deletes(Keys, Tree, nocheck).","ref":"jhn_pb_tree.html#deletes/2"},{"type":"function","title":"jhn_pb_tree.deletes/3","doc":"A tree that has all the associations for the keys removed. If there is no value associated with any of the Keys in the Tree, the flag determines what happens. If the flag is check an exception is generated if, if the flag is nocheck a tree is returned with the other associations removed.","ref":"jhn_pb_tree.html#deletes/3"},{"type":"function","title":"jhn_pb_tree.find/2","doc":"Returns the value associated with the longest prefix of the Key in the Tree or undefined if no such association exists. The call find(Key, Tree) is equivalent to find(Key, Tree, undefined).","ref":"jhn_pb_tree.html#find/2"},{"type":"function","title":"jhn_pb_tree.find/3","doc":"Returns the value associated with the longest prefix of the Key in the Tree or Default if no such association exists.","ref":"jhn_pb_tree.html#find/3"},{"type":"function","title":"jhn_pb_tree.from_list/1","doc":"For each {Key, Value} pair in Pairs the value is stored under the key in the Tree.","ref":"jhn_pb_tree.html#from_list/1"},{"type":"function","title":"jhn_pb_tree.is_empty/1","doc":"Returns true if the Tree is empty, false otherwise.","ref":"jhn_pb_tree.html#is_empty/1"},{"type":"function","title":"jhn_pb_tree.is_pb_tree/1","doc":"Returns true if X is a P-tree, false otherwise.","ref":"jhn_pb_tree.html#is_pb_tree/1"},{"type":"function","title":"jhn_pb_tree.keys/1","doc":"Returns all the keys in ascending order.","ref":"jhn_pb_tree.html#keys/1"},{"type":"function","title":"jhn_pb_tree.member/2","doc":"Returns true if there is a value associated with Key in the tree, otherwise false.","ref":"jhn_pb_tree.html#member/2"},{"type":"function","title":"jhn_pb_tree.new/0","doc":"Creates an empty P-tree.","ref":"jhn_pb_tree.html#new/0"},{"type":"function","title":"jhn_pb_tree.replace/3","doc":"Replaces any existing value associated with Key in the tree, otherwise adds a association for the value with the Key. The call replace(Key, Value, Tree) is equivalent to replace(Key, Value, Tree, nocheck).","ref":"jhn_pb_tree.html#replace/3"},{"type":"function","title":"jhn_pb_tree.replace/4","doc":"Replaces any existing value associated with Key in the tree, otherwise the flag determines what happens. If the flag is check an exception is generated, otherwise the value is added.","ref":"jhn_pb_tree.html#replace/4"},{"type":"function","title":"jhn_pb_tree.to_list/1","doc":"From a P-tree a list of {Key, Value} pairs.","ref":"jhn_pb_tree.html#to_list/1"},{"type":"function","title":"jhn_pb_tree.values/1","doc":"Returns all the values in ascending order of their keys.","ref":"jhn_pb_tree.html#values/1"},{"type":"type","title":"jhn_pb_tree.default/0","doc":null,"ref":"jhn_pb_tree.html#t:default/0"},{"type":"type","title":"jhn_pb_tree.flag/0","doc":null,"ref":"jhn_pb_tree.html#t:flag/0"},{"type":"type","title":"jhn_pb_tree.key/0","doc":null,"ref":"jhn_pb_tree.html#t:key/0"},{"type":"opaque","title":"jhn_pb_tree.pb_tree/0","doc":null,"ref":"jhn_pb_tree.html#t:pb_tree/0"},{"type":"type","title":"jhn_pb_tree.value/0","doc":null,"ref":"jhn_pb_tree.html#t:value/0"},{"type":"module","title":"jhn_plist","doc":"A property list style handling of {Key, Value} tuples.","ref":"jhn_plist.html"},{"type":"function","title":"jhn_plist.add/3","doc":"Extends Plist with the property without checking if it exists.","ref":"jhn_plist.html#add/3"},{"type":"function","title":"jhn_plist.add/4","doc":"Extends Plist with the property checking if it exists if required.","ref":"jhn_plist.html#add/4"},{"type":"function","title":"jhn_plist.compact/1","doc":"Ensures one property per key, with the first given precedence.","ref":"jhn_plist.html#compact/1"},{"type":"function","title":"jhn_plist.delete/2","doc":"Restricts Plist on the key without checking if it exists.","ref":"jhn_plist.html#delete/2"},{"type":"function","title":"jhn_plist.delete/3","doc":"Restricts Plist on the key without checking if it exists if required.","ref":"jhn_plist.html#delete/3"},{"type":"function","title":"jhn_plist.find/2","doc":"Finds the value of the property or undefined if not found.","ref":"jhn_plist.html#find/2"},{"type":"function","title":"jhn_plist.find/3","doc":"Finds the value of the property or Default if not found.","ref":"jhn_plist.html#find/3"},{"type":"function","title":"jhn_plist.find/4","doc":"Finds the value of the property or Default if not found. If more than property is found the one returned if determined by the Placement as being the first or last.","ref":"jhn_plist.html#find/4"},{"type":"function","title":"jhn_plist.find_all/2","doc":"Finds the all values associated with the key.","ref":"jhn_plist.html#find_all/2"},{"type":"function","title":"jhn_plist.keys/1","doc":"Returns all the keys.","ref":"jhn_plist.html#keys/1"},{"type":"function","title":"jhn_plist.member/2","doc":"Returns wether the key is to be found in the PList.","ref":"jhn_plist.html#member/2"},{"type":"function","title":"jhn_plist.new/0","doc":"Creates an empty plist.","ref":"jhn_plist.html#new/0"},{"type":"function","title":"jhn_plist.new/2","doc":"Creates a plist from the zipping the lists of keys and values.","ref":"jhn_plist.html#new/2"},{"type":"function","title":"jhn_plist.replace/3","doc":"Replaces the first occurence in the PList, adding if it if not found.","ref":"jhn_plist.html#replace/3"},{"type":"function","title":"jhn_plist.replace/4","doc":"Replaces the first occurence in the PList, esuring that i does exist if required.","ref":"jhn_plist.html#replace/4"},{"type":"function","title":"jhn_plist.values/1","doc":"Returns all the values.","ref":"jhn_plist.html#values/1"},{"type":"type","title":"jhn_plist.default/0","doc":null,"ref":"jhn_plist.html#t:default/0"},{"type":"type","title":"jhn_plist.flag/0","doc":null,"ref":"jhn_plist.html#t:flag/0"},{"type":"type","title":"jhn_plist.key/0","doc":null,"ref":"jhn_plist.html#t:key/0"},{"type":"type","title":"jhn_plist.placement/0","doc":null,"ref":"jhn_plist.html#t:placement/0"},{"type":"type","title":"jhn_plist.plist/0","doc":null,"ref":"jhn_plist.html#t:plist/0"},{"type":"type","title":"jhn_plist.value/0","doc":null,"ref":"jhn_plist.html#t:value/0"},{"type":"module","title":"jhn_r_tree","doc":"Implements range trees, where the tree is organized with non-overlapping ranges.","ref":"jhn_r_tree.html"},{"type":"function","title":"jhn_r_tree.add/3","doc":"The Value is saved in Tree under the Range, if that key is present the value associated with the key is replaced by Value. add(Range, Value, Tree) is equivalent to add(Range, Value, Tree,nocheck).","ref":"jhn_r_tree.html#add/3"},{"type":"function","title":"jhn_r_tree.add/4","doc":"The Value is saved in Tree under the Range, if that key is present the value associated with the key is replaced by Value. If the flag is check an exception is generated and if nocheck the value is replaced.","ref":"jhn_r_tree.html#add/4"},{"type":"function","title":"jhn_r_tree.adds/2","doc":null,"ref":"jhn_r_tree.html#adds/2"},{"type":"function","title":"jhn_r_tree.adds/3","doc":"For each {Range, Value} pair in Pairs the value is stored under the Range in the Tree. If an Range already has a value associated with in the Tree the flag determines what happens. If the flag is check an exception is generated if a range has a value associated with it, if the flag is nocheck the values will be replaced.","ref":"jhn_r_tree.html#adds/3"},{"type":"function","title":"jhn_r_tree.delete/2","doc":"If a value is associated the Range the Tree returned has that association removed. The call delete(Range, Tree) is equivalent to delete(Range, Tree, nocheck).","ref":"jhn_r_tree.html#delete/2"},{"type":"function","title":"jhn_r_tree.delete/3","doc":"If a value is associated the Range the Tree returned has that association removed. If there is no value associated with the Range in the Tree the flag determines what happens. If the flag is check an exception is generated if no association exists, if the flag is nocheck the unchanged tree is returned.","ref":"jhn_r_tree.html#delete/3"},{"type":"function","title":"jhn_r_tree.deletes/2","doc":"A tree that has all the associations for the ranges removed. The call deletes(Ranges, Tree) is equivalent to deletes(Ranges, Tree, nocheck).","ref":"jhn_r_tree.html#deletes/2"},{"type":"function","title":"jhn_r_tree.deletes/3","doc":"A tree that has all the associations for the rangess removed. If there is no value associated with any of the Ranges in the Tree, the flag determines what happens. If the flag is check an exception is generated if, if the flag is nocheck a tree is returned with the other associations removed.","ref":"jhn_r_tree.html#deletes/3"},{"type":"function","title":"jhn_r_tree.find/2","doc":"Returns the value associated with any range that includes the key in the Tree or undefined if no such association exists. The call find(Key, Tree) is equivalent to find(Key, Tree, undefined).","ref":"jhn_r_tree.html#find/2"},{"type":"function","title":"jhn_r_tree.find/3","doc":"Returns the value associated with any range that includes the key in the Tree or Default if no such association exists.","ref":"jhn_r_tree.html#find/3"},{"type":"function","title":"jhn_r_tree.from_list/1","doc":"For each {Range, Value} pair in Pairs the value is stored under the key in the Tree.","ref":"jhn_r_tree.html#from_list/1"},{"type":"function","title":"jhn_r_tree.is_empty/1","doc":"Returns true if the Tree is empty, false otherwise.","ref":"jhn_r_tree.html#is_empty/1"},{"type":"function","title":"jhn_r_tree.is_r_tree/1","doc":"Returns true if X is a R-tree, false otherwise.","ref":"jhn_r_tree.html#is_r_tree/1"},{"type":"function","title":"jhn_r_tree.member/2","doc":"Returns true if there is a value associated with Range in the tree, otherwise false.","ref":"jhn_r_tree.html#member/2"},{"type":"function","title":"jhn_r_tree.new/0","doc":"Creates an empty R-tree.","ref":"jhn_r_tree.html#new/0"},{"type":"function","title":"jhn_r_tree.ranges/1","doc":"Returns all the ranges in ascending order.","ref":"jhn_r_tree.html#ranges/1"},{"type":"function","title":"jhn_r_tree.replace/3","doc":"Replaces any existing value associated with Range in the tree, otherwise adds a association for the value with the Range. The call replace(Range, Value, Tree) is equivalent to replace(Range, Value, Tree, nocheck).","ref":"jhn_r_tree.html#replace/3"},{"type":"function","title":"jhn_r_tree.replace/4","doc":"Replaces any existing value associated with Range in the tree, otherwise the flag determines what happens. If the flag is check an exception is generated, otherwise the value is added.","ref":"jhn_r_tree.html#replace/4"},{"type":"function","title":"jhn_r_tree.to_list/1","doc":"From a R-tree a list of {Range, Value} pairs.","ref":"jhn_r_tree.html#to_list/1"},{"type":"function","title":"jhn_r_tree.values/1","doc":"Returns all the values in ascending order of their ranges.","ref":"jhn_r_tree.html#values/1"},{"type":"type","title":"jhn_r_tree.default/0","doc":null,"ref":"jhn_r_tree.html#t:default/0"},{"type":"type","title":"jhn_r_tree.flag/0","doc":null,"ref":"jhn_r_tree.html#t:flag/0"},{"type":"type","title":"jhn_r_tree.key/0","doc":null,"ref":"jhn_r_tree.html#t:key/0"},{"type":"opaque","title":"jhn_r_tree.r_tree/0","doc":null,"ref":"jhn_r_tree.html#t:r_tree/0"},{"type":"type","title":"jhn_r_tree.range/0","doc":null,"ref":"jhn_r_tree.html#t:range/0"},{"type":"type","title":"jhn_r_tree.value/0","doc":null,"ref":"jhn_r_tree.html#t:value/0"},{"type":"behaviour","title":"jhn_server","doc":"This is a generic server in the spirit of OTP's gen_server but subtly different. The behaviour module provides the server of a client-server relation. A generic server process (jhn_server) implemented using this module has a standard set of interface functions. It also fits into an OTP supervision tree and supports generic OTP tooling for, e.g., dynamic upgrades. A jhn_server process assumes all specific parts to be located in a callback module exporting a predefined set of functions, some optional. The relationship between the behavior functions and the callback functions is as follows: -----&gt;/-----&gt; fuction call/return ====&gt; message sent User module: &lt;-------------&gt; jhn_server module: &lt;--/==&gt; Callback module: ----------------------------------------------------------------------- jhn_server:create/1/2 -----&gt; proc_lib:spawn ----&gt; init/1 jhn_server:create/1/2 &lt;----- proc_lib:spawn &lt;==== init/1 ----------------------------------------------------------------------- jhn_server:call/2/3 =====&gt; (jhn_server) -----&gt; request/2 jhn_server:call/2/3 &lt;===== (jhn_server) &lt;----- jhn_server:reply/1/2 (optional) ----------------------------------------------------------------------- jhn_server:sync/1/2 =====&gt; (jhn_server) jhn_server:sync/1/2 &lt;===== (jhn_server) ----------------------------------------------------------------------- jhn_server:cast/2/3 =====&gt; (jhn_server) -----&gt; request/2 All the following are optional Other process =====&gt; Callback module ----------------------------------------------------------------------- Id ! Message =====&gt; message/2 sys:terminate/2 =====&gt; terminate/3 sys:code_change/4 =====&gt; code_change/3 sys:get_status/2 =====&gt; format_status/2 If a callback function fails or returns a bad value, the jhn_server process terminates. N.B. that a gen_server process does not trap exit signals automatically, this must be explicitly initiated in the callback module. The process is by default linked to the parent. jhn_server supports hibernation. Any call, cast or plain message sent to the process that has not a matching clause in the appropriate request/2 or messsage/2 call back function will be discarded and logged as unexpected. If the optional callback funtion message/2 is not defined there are no matching function clauses at all. The callback module shall export: init(Args) ==&gt; {ok, State} | {hibernate, State} | ignore | {error, stop} | {stop, Reason} request(Msg, State) ==&gt; {ok, State} | {hibernate, State} | {stop, Reason} The callback module can export: message(Msg, State) ==&gt; {ok, State} | {hibernate, State} | {stop, Reason} terminate(Reason, State) ==&gt; Return value ignored Lets the user module clean up always called when server terminates code_change(OldVsn, Data, Extra) ==&gt; {ok, State} format_status(Opt, _) ==&gt; {ok, State} Uses the old format will be replaced.","ref":"jhn_server.html"},{"type":"function","title":"jhn_server.abcast/2","doc":"A cast is made to servers registered as Server on all the connected nodes.","ref":"jhn_server.html#abcast/2"},{"type":"function","title":"jhn_server.abcast/3","doc":"A cast is made to servers registered as Server on all Nodes.","ref":"jhn_server.html#abcast/3"},{"type":"function","title":"jhn_server.call/2","doc":"A call is made to Server with default timeout 5000ms.","ref":"jhn_server.html#call/2"},{"type":"function","title":"jhn_server.call/3","doc":"A call is made to Server with Timeout. Will generate a timeout exception if the Server takes more than Timeout time to answer. Generates an exception if the process is dead, dies, or no process registered under that name. If the server replies that is returned from the call.","ref":"jhn_server.html#call/3"},{"type":"function","title":"jhn_server.cancel/1","doc":"A timer a timer started using delayed_cast/2, returns time remaining or false.","ref":"jhn_server.html#cancel/1"},{"type":"function","title":"jhn_server.cast/2","doc":"A cast is made to the server, allways returns ok.","ref":"jhn_server.html#cast/2"},{"type":"callback","title":"jhn_server.code_change/3","doc":null,"ref":"jhn_server.html#c:code_change/3"},{"type":"function","title":"jhn_server.create/1","doc":"Creates a jhn_server.","ref":"jhn_server.html#create/1"},{"type":"function","title":"jhn_server.create/2","doc":"Creates a jhn_server with options. Options are: {link, Boolean} -&gt; if the server is linked to the parent, default true {timeout, infinity | Integer} -&gt; Time in ms for the server to create and initialise, after that an exception is generated, default 5000. {name, Atom} -&gt; name that the server is registered under. {arg, Term} -&gt; argument provided to the init/1 callback function, default is 'no_arg'.","ref":"jhn_server.html#create/2"},{"type":"function","title":"jhn_server.delayed_cast/2","doc":"A cast is made to the calling Server after Delay ms, always returns a timer reference that can be canceled using cancel/1.","ref":"jhn_server.html#delayed_cast/2"},{"type":"callback","title":"jhn_server.format_status/2","doc":null,"ref":"jhn_server.html#c:format_status/2"},{"type":"function","title":"jhn_server.from/0","doc":"Called inside a request/2 of callback function for a call it will provide an opaque data data enables a reply to the call outside the scope of the callback function.","ref":"jhn_server.html#from/0"},{"type":"callback","title":"jhn_server.init/1","doc":null,"ref":"jhn_server.html#c:init/1"},{"type":"callback","title":"jhn_server.message/2","doc":null,"ref":"jhn_server.html#c:message/2"},{"type":"function","title":"jhn_server.reply/1","doc":"Called inside callback function to provide reply to a call.","ref":"jhn_server.html#reply/1"},{"type":"function","title":"jhn_server.reply/2","doc":"Called by any process will send a reply to the one that sent the request to the server, the From argument is the result from a call to from/1 inside a request/2 callback function in response to a jhn_server:call/2/3","ref":"jhn_server.html#reply/2"},{"type":"callback","title":"jhn_server.request/2","doc":null,"ref":"jhn_server.html#c:request/2"},{"type":"function","title":"jhn_server.sync/1","doc":"A synchronization is made with Server with default timeout 5000ms.","ref":"jhn_server.html#sync/1"},{"type":"function","title":"jhn_server.sync/2","doc":"A synchronization is made with Server with Timeout. Will generate a timeout exception if the Server takes more than Timeout time to answer. Generates an exception if the process is dead, dies, or no process registered under that name. If the server returns, ok is returned.","ref":"jhn_server.html#sync/2"},{"type":"callback","title":"jhn_server.terminate/3","doc":null,"ref":"jhn_server.html#c:terminate/3"},{"type":"function","title":"jhn_server.type/0","doc":"Called inside a request/2 and it tells if it is a call or a cast.","ref":"jhn_server.html#type/0"},{"type":"type","title":"jhn_server.from/0","doc":null,"ref":"jhn_server.html#t:from/0"},{"type":"type","title":"jhn_server.init_return/1","doc":null,"ref":"jhn_server.html#t:init_return/1"},{"type":"type","title":"jhn_server.opt/0","doc":null,"ref":"jhn_server.html#t:opt/0"},{"type":"type","title":"jhn_server.opts/0","doc":null,"ref":"jhn_server.html#t:opts/0"},{"type":"type","title":"jhn_server.return/1","doc":null,"ref":"jhn_server.html#t:return/1"},{"type":"type","title":"jhn_server.server_ref/0","doc":null,"ref":"jhn_server.html#t:server_ref/0"},{"type":"module","title":"jhn_shttpc","doc":"A simple HTTP client based on: Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing (rfc7230) Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content (rfc7231) The Hypertext Transfer Protocol Status Code 308 (Permanent Redirect) (rfc7538) PATCH Method for HTTP (rfc5789) HTTP Over TLS (rfc2818) Options that are available to open/1, open/2 and all HTTP method functions: timeout -&gt; the time in milliseconds the request is allowed to complete limit -&gt; the endtime for the request as system_time in milliseconds headers -&gt; a map of HTTP headers where the headers name can be an atom or binary and the value a binary options -&gt; options to the transport's (tcp or ssl) connection function redirect -&gt; a boolean that determines if redirect are automatically followed for status codes 301, 302, 303, 307, 308 and in the case of 303 use the GET as the method close -&gt; a boolean that determines if the connection should be closed by this client upon completion of the function connection -&gt; if present provides an already established connection to server that will be used for the request Returned by open/1, open/2 and all HTTP method functions is a map with: status -&gt; {Code, Text} where the code is an integer and Text a binary headers -&gt; a map of HTTP headers from the server reply, recognised names ones are returned as atoms body -&gt; the body of the server reply as a binary, possibly empty connection -&gt; present if neither the server ot the client closed the connection, the value is opaque and should used in later HTTP mehod calls N.B. The established connections do not time out, if not closed explicitly they will remain and cause a resource leak. For HTTPS requires the ssl OTP lib which is not included in the application resource file. Only supports R18 and later.","ref":"jhn_shttpc.html"},{"type":"function","title":"jhn_shttpc.close/1","doc":"Closes an already established connection.","ref":"jhn_shttpc.html#close/1"},{"type":"function","title":"jhn_shttpc.connect/1","doc":"Performs the CONNECT HTTP method","ref":"jhn_shttpc.html#connect/1"},{"type":"function","title":"jhn_shttpc.connect/2","doc":"Performs the CONNECT HTTP method","ref":"jhn_shttpc.html#connect/2"},{"type":"function","title":"jhn_shttpc.delete/1","doc":"Performs the DELETE HTTP method","ref":"jhn_shttpc.html#delete/1"},{"type":"function","title":"jhn_shttpc.delete/2","doc":"Performs the DELET HTTP method","ref":"jhn_shttpc.html#delete/2"},{"type":"function","title":"jhn_shttpc.get/1","doc":"Performs the GET HTTP method","ref":"jhn_shttpc.html#get/1"},{"type":"function","title":"jhn_shttpc.get/2","doc":"Performs the GET HTTP method","ref":"jhn_shttpc.html#get/2"},{"type":"function","title":"jhn_shttpc.head/1","doc":"Performs the HEAD HTTP method","ref":"jhn_shttpc.html#head/1"},{"type":"function","title":"jhn_shttpc.head/2","doc":"Performs the HEAD HTTP method","ref":"jhn_shttpc.html#head/2"},{"type":"function","title":"jhn_shttpc.open/1","doc":"Opens a connection for later use, uses the HTTP HEAD method.","ref":"jhn_shttpc.html#open/1"},{"type":"function","title":"jhn_shttpc.open/2","doc":"Opens a connection for later use, uses the HTTP Method.","ref":"jhn_shttpc.html#open/2"},{"type":"function","title":"jhn_shttpc.options/1","doc":"Performs the OPTIONS HTTP method","ref":"jhn_shttpc.html#options/1"},{"type":"function","title":"jhn_shttpc.options/2","doc":"Performs the OPTIONS HTTP method","ref":"jhn_shttpc.html#options/2"},{"type":"function","title":"jhn_shttpc.patch/2","doc":"Performs the PATCH HTTP method","ref":"jhn_shttpc.html#patch/2"},{"type":"function","title":"jhn_shttpc.patch/3","doc":"Performs the PATCH HTTP method","ref":"jhn_shttpc.html#patch/3"},{"type":"function","title":"jhn_shttpc.post/2","doc":"Performs the POST HTTP method","ref":"jhn_shttpc.html#post/2"},{"type":"function","title":"jhn_shttpc.post/3","doc":"Performs the POST HTTP method","ref":"jhn_shttpc.html#post/3"},{"type":"function","title":"jhn_shttpc.put/1","doc":"Performs the PUT HTTP method","ref":"jhn_shttpc.html#put/1"},{"type":"function","title":"jhn_shttpc.put/2","doc":"Performs the PUT HTTP method","ref":"jhn_shttpc.html#put/2"},{"type":"function","title":"jhn_shttpc.put/3","doc":"Performs the PUT HTTP method","ref":"jhn_shttpc.html#put/3"},{"type":"function","title":"jhn_shttpc.trace/1","doc":"Performs the TRACE HTTP method","ref":"jhn_shttpc.html#trace/1"},{"type":"function","title":"jhn_shttpc.trace/2","doc":"Performs the TRACE HTTP method","ref":"jhn_shttpc.html#trace/2"},{"type":"opaque","title":"jhn_shttpc.connection/0","doc":null,"ref":"jhn_shttpc.html#t:connection/0"},{"type":"type","title":"jhn_shttpc.method/0","doc":null,"ref":"jhn_shttpc.html#t:method/0"},{"type":"module","title":"jhn_syslog","doc":"A Syslog library based on: The Syslog Protocol (rfc5424) Transport Layer Security (TLS) Transport Mapping for Syslog (rfc5425) Transmission of Syslog Messages over UDP (rfc5426) Textual Conventions for Syslog Management (rfc5427) Transmission of Syslog Messages over TCP (rfc6587) Datagram Transport Layer Security (DTLS) Transport Mapping for Syslog (rfc6012) SYSLOG line is represented as follows: line : #{header =&gt; Header, structured =&gt; Structured, msg =&gt; Message } Header : #{facility =&gt; Facility, severity =&gt; Severity, version =&gt; Version, time_stamp =&gt; TimeStamp, fraction =&gt; integer(), offset_sign =&gt; '+' | '-' | 'Z', offset =&gt; {Hour, Minute}, host_name =&gt; iodata(), app_name =&gt; iodata(), proc_id =&gt; iodata(), msg_id =&gt; iodata() } Facility : kern | user | mail | daemon | auth | syslog | lpr | news | uucp | cron | authpriv | ftp | ntp | audit | console | cron2 | local0 | local1 | local2 | local3 | local4 | local5 | local6 | local7 default: user Severity : emerg | alert | crit | err | warning | notice | info | debug default: info Version : integer() default: 1 TimeStamp : binary() | {{Year, Month, Day}, {Hour, Minute, Second}} | #{year =&gt; Year, month =&gt; Month, day =&gt; Day, hour =&gt;Hour, minute =&gt; Minute, second =&gt; Second} Year, Month, Day, Hour, Minute, Second : integer() Structured : [{Id, [{Key, Value}]}] Id, Key, Value : iodata() Message : #{type =&gt; utf8 | any, content =&gt; iodata() } All part of the map are optional. All iodata is in fact a binary when a line is decoded. All header values that can be represented by the nil element &quot;-&quot; has that as default and when decoded omitted from the returned map. N.B. TCP only supports Octet counting framing. The TLS transport requires the ssl OTP lib which is not included in the application resource file. The DTLS transport requires the ssl OTP lib which is not included in the application resource file.","ref":"jhn_syslog.html"},{"type":"function","title":"jhn_syslog.accept/1","doc":"Accepts an incoming connection request on an opened server transport for the TCP and TLS, it returns a connected transport. Equivalent to accept(Transport, []).","ref":"jhn_syslog.html#accept/1"},{"type":"function","title":"jhn_syslog.accept/2","doc":"Accepts an incoming connection request on an opened server transport for the TCP and TLS, it returns a connected transport. Options are: timeout -&gt; the time in milliseconds the request is allowed to complete","ref":"jhn_syslog.html#accept/2"},{"type":"function","title":"jhn_syslog.close/1","doc":"Closes an already established transport.","ref":"jhn_syslog.html#close/1"},{"type":"function","title":"jhn_syslog.controlling_process/2","doc":"Assigns a new controlling process Pid to the Transport socket.","ref":"jhn_syslog.html#controlling_process/2"},{"type":"function","title":"jhn_syslog.decode/1","doc":"Decodes the binary into a structured Erlang term. Equivalent to decode(Binary, [])","ref":"jhn_syslog.html#decode/1"},{"type":"function","title":"jhn_syslog.decode/2","doc":"Decodes the binary into a structured Erlang. Decode will give an exception if the binary is not well formed Syslog line. Options are: currently none N.B. the timestamp is decode into a date time tuple.","ref":"jhn_syslog.html#decode/2"},{"type":"function","title":"jhn_syslog.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent to encode(Line, []).","ref":"jhn_syslog.html#encode/1"},{"type":"function","title":"jhn_syslog.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: seconds (default) -&gt; second precision milli -&gt; milli second precision micro -&gt; micro second precision binary -&gt; a binary is returned iolist -&gt; a iolist is returned","ref":"jhn_syslog.html#encode/2"},{"type":"function","title":"jhn_syslog.frame/2","doc":"Encloses an encoded line in an octet counting frame.","ref":"jhn_syslog.html#frame/2"},{"type":"function","title":"jhn_syslog.open/0","doc":"Opens an UDP client or server transport. Equivalent to open([]).","ref":"jhn_syslog.html#open/0"},{"type":"function","title":"jhn_syslog.open/1","doc":"Opens a Transport returning a connected client connection or a listen port for DTLS/TCP/TLS for the server, UDP the difference is quite moot. Options are: client -&gt; opens a client transport (default) server -&gt; open a server transport udp -&gt; uses the UDP protocol (default) dtls -&gt; uses the DTLS v1.2 over UDP tcp -&gt; uses the TCP protocol tls -&gt; uses TLS v1.2(default) or TLS v1.3 over TCP ipv4 -&gt; IPv4 addresses are used (default) ipv6 -&gt; IPv6 addresses are used port -&gt; The port used by client or server with the default in the client case is 0 (the underlying OS assigns an available port number) for the server the default ports are as follows: UDP/514, UDP/6514, TCP/601, TLS/6514 destination -&gt; the IP address or hostname of the server to connect to in the case TCP and TLS and the default server for the UDP/DTLS case destination_port -&gt; the port of the server to connect to in the case TCP/TLS and the default server for the UDP/DTLS case version -&gt; the version used for TLS, v1.2(default) or v1.3. opts -&gt; options to the transport's UDP, DTLS, TCP, or TLS, see the documentation of gen_udp, gen_tcp, ssl respectively timeout -&gt; the time in milliseconds the request is allowed to complete","ref":"jhn_syslog.html#open/1"},{"type":"function","title":"jhn_syslog.recv/1","doc":"Receives a packet from a Transport socket in passive mode. A closed socket is indicated by a return value {error, closed}. Equivalent to recv(Line, []).","ref":"jhn_syslog.html#recv/1"},{"type":"function","title":"jhn_syslog.recv/2","doc":"Receives a packet from a Transport socket in passive mode. A closed socket is indicated by a return value {error, closed}. Options are: timeout -&gt; the time in milliseconds the request is allowed to complete","ref":"jhn_syslog.html#recv/2"},{"type":"function","title":"jhn_syslog.send/2","doc":"Sends a message over the transport. Equivalent to Send(Transport, Line).","ref":"jhn_syslog.html#send/2"},{"type":"function","title":"jhn_syslog.send/3","doc":"Sends a message over the transport. Options are: seconds (default) -&gt; second precision milli -&gt; milli second precision micro -&gt; micro second precision destination -&gt; the IP address or hostname of the peer to send to in the UDP case, otherwise the default provided in open is used destination_port -&gt; the port of the peer in the UDP case","ref":"jhn_syslog.html#send/3"},{"type":"function","title":"jhn_syslog.setopts/2","doc":"Sets one or more options for a transport socket according to the transport.","ref":"jhn_syslog.html#setopts/2"},{"type":"function","title":"jhn_syslog.unframe/2","doc":"Extracts the line from an octet counting frame.","ref":"jhn_syslog.html#unframe/2"},{"type":"type","title":"jhn_syslog.line/0","doc":null,"ref":"jhn_syslog.html#t:line/0"},{"type":"type","title":"jhn_syslog.listen_type/0","doc":null,"ref":"jhn_syslog.html#t:listen_type/0"},{"type":"type","title":"jhn_syslog.opt/0","doc":null,"ref":"jhn_syslog.html#t:opt/0"},{"type":"type","title":"jhn_syslog.socket_options/0","doc":null,"ref":"jhn_syslog.html#t:socket_options/0"},{"type":"type","title":"jhn_syslog.transport/0","doc":null,"ref":"jhn_syslog.html#t:transport/0"},{"type":"type","title":"jhn_syslog.type/0","doc":null,"ref":"jhn_syslog.html#t:type/0"},{"type":"module","title":"jhn_t_tree","doc":"Implements T-trees extended with an notion of least upp and greatest lower bounds. For more information on T-Trees see: A Study of Index Structures for Main Memory Database Management Systems. by Tobin J. Lehman and Michael J. Carey, VLDB 1986.","ref":"jhn_t_tree.html"},{"type":"function","title":"jhn_t_tree.add/3","doc":"The Value is saved under the Index in the Tree, if that index is present the value associated with the index is replaced by Value. add(Index, Value, Tree) is equivalent to add(Index, Value, Tree, nocheck).","ref":"jhn_t_tree.html#add/3"},{"type":"function","title":"jhn_t_tree.add/4","doc":"The Value is saved under the Index in the Tree, the Flag determines what should happen if that index already has a value associated with in the Tree. If the flag is check an exception is generated and if nocheck the value is replaced.","ref":"jhn_t_tree.html#add/4"},{"type":"function","title":"jhn_t_tree.adds/2","doc":"For each {Index, Value} pair in Pairs the value is stored under the index in the Tree. The adds(Pairs, Tree) call is equivalent to adds(Pairs, Tree, nocheck).","ref":"jhn_t_tree.html#adds/2"},{"type":"function","title":"jhn_t_tree.adds/3","doc":"For each {Index, Value} pair in Pairs the value is stored under the index in the Tree. If an index already has a value associated with in the Tree the flag determines what happens. If the flag is check an exception is generated if a index has a value associated with it, if the flag is nocheck the values will be replaced.","ref":"jhn_t_tree.html#adds/3"},{"type":"function","title":"jhn_t_tree.delete/2","doc":"If a value is associated the Index the Tree returned has that association removed. The call delete(Index, Tree) is equivalent to delete(Index, Tree, nocheck).","ref":"jhn_t_tree.html#delete/2"},{"type":"function","title":"jhn_t_tree.delete/3","doc":"If a value is associated the Index the Tree returned has that association removed. If there is no value associated with the Index in the Tree the flag determines what happens. If the flag is check an exception is generated if no association exists, if the flag is nocheck the unchanged tree is returned.","ref":"jhn_t_tree.html#delete/3"},{"type":"function","title":"jhn_t_tree.deletes/2","doc":"A tree that has all the associations for the indices removed. The call deletes(Indces, Tree) is equivalent to deletes(Indces, Tree, nocheck).","ref":"jhn_t_tree.html#deletes/2"},{"type":"function","title":"jhn_t_tree.deletes/3","doc":"A tree that has all the associations for the indices removed. If there is no value associated with any of the Indices in the Tree, the flag determines what happens. If the flag is check an exception is generated if, if the flag is nocheck a tree is returned with the other associations removed.","ref":"jhn_t_tree.html#deletes/3"},{"type":"function","title":"jhn_t_tree.find/2","doc":"Returns the value associated with Index in the Tree or undefined if no such association exists. The call find(Index, Tree) is equivalent to find(Index, Tree, undefined).","ref":"jhn_t_tree.html#find/2"},{"type":"function","title":"jhn_t_tree.find/3","doc":"Returns the value associated with Index in the Tree or Default if no such association exists.","ref":"jhn_t_tree.html#find/3"},{"type":"function","title":"jhn_t_tree.first/1","doc":"Returns the value of the smallest index in the Tree or undefined if the tree is empty. The call first(Tree) if equivalent to first(Tree, undefined).","ref":"jhn_t_tree.html#first/1"},{"type":"function","title":"jhn_t_tree.first/2","doc":"Returns the value of the smallest index in the Tree or Default if the tree is empty.","ref":"jhn_t_tree.html#first/2"},{"type":"function","title":"jhn_t_tree.from_list/1","doc":"For each {Index, Value} pair in Pairs the value is stored under the index in the Tree. Equivalent to from_list(Pairs, []).","ref":"jhn_t_tree.html#from_list/1"},{"type":"function","title":"jhn_t_tree.greatest_lower_bound/2","doc":"Returns the value of the largest index that is less or equal to to Index that has a value associated with it, or undefined if no such index exists. The call greatest_lower_bound(Index, Tree) is equivalent to greatest_lower_bound(Index, Tree, undefined).","ref":"jhn_t_tree.html#greatest_lower_bound/2"},{"type":"function","title":"jhn_t_tree.greatest_lower_bound/3","doc":"Returns the value of the largest index that is less or equal to to Index that has a value associated with it, or Default if no such index exists.","ref":"jhn_t_tree.html#greatest_lower_bound/3"},{"type":"function","title":"jhn_t_tree.indices/1","doc":"Returns all the indices in ascending order.","ref":"jhn_t_tree.html#indices/1"},{"type":"function","title":"jhn_t_tree.is_empty/1","doc":"Returns true if the Tree is empty, false otherwise.","ref":"jhn_t_tree.html#is_empty/1"},{"type":"function","title":"jhn_t_tree.is_t_tree/1","doc":"Returns true if X is a t_tree, false otherwise.","ref":"jhn_t_tree.html#is_t_tree/1"},{"type":"function","title":"jhn_t_tree.last/1","doc":"Returns the value of the largest index in the Tree or undefined if the tree is empty. The call last(Tree) if equivalent to last(Tree, undefined).","ref":"jhn_t_tree.html#last/1"},{"type":"function","title":"jhn_t_tree.last/2","doc":"Returns the value of the largest index in the Tree or Default if the tree is empty.","ref":"jhn_t_tree.html#last/2"},{"type":"function","title":"jhn_t_tree.least_upper_bound/2","doc":"Returns the value of the smallest index that is greater or equal to to Index that has a value associated with it, or undefined if no such index exists. The call least_upper_bound(Index, Tree) is equivalent to least_upper_bound(Index, Tree, undefined).","ref":"jhn_t_tree.html#least_upper_bound/2"},{"type":"function","title":"jhn_t_tree.least_upper_bound/3","doc":"Returns the value of the smallest index that is greater or equal to to Index that has a value associated with it, or Default if no such index exists.","ref":"jhn_t_tree.html#least_upper_bound/3"},{"type":"function","title":"jhn_t_tree.member/2","doc":"Returns true if there is a value associated with Index in the tree, otherwise false.","ref":"jhn_t_tree.html#member/2"},{"type":"function","title":"jhn_t_tree.new/0","doc":"Creates an empty T-tree. The call new() is equivalent to new([]).","ref":"jhn_t_tree.html#new/0"},{"type":"function","title":"jhn_t_tree.new/1","doc":"Creates an empty T-tree with min and max internal size according to the options.","ref":"jhn_t_tree.html#new/1"},{"type":"function","title":"jhn_t_tree.replace/3","doc":"Replaces any existing value associated with Index in the tree, otherwise adds a association for the value with the Index. The call replace(Index, Value, Tree) is equivalent to replace(Index, Value, Tree, nocheck).","ref":"jhn_t_tree.html#replace/3"},{"type":"function","title":"jhn_t_tree.replace/4","doc":"Replaces any existing value associated with Index in the tree, otherwise the flag determines what happens. If the flag is check an exception is generated, otherwise the value is added.","ref":"jhn_t_tree.html#replace/4"},{"type":"function","title":"jhn_t_tree.to_list/1","doc":"From a T-tree a list of {Index, Value} pairs.","ref":"jhn_t_tree.html#to_list/1"},{"type":"function","title":"jhn_t_tree.values/1","doc":"Returns all the values in ascending order of their indeces.","ref":"jhn_t_tree.html#values/1"},{"type":"type","title":"jhn_t_tree.default/0","doc":null,"ref":"jhn_t_tree.html#t:default/0"},{"type":"type","title":"jhn_t_tree.flag/0","doc":null,"ref":"jhn_t_tree.html#t:flag/0"},{"type":"type","title":"jhn_t_tree.index/0","doc":null,"ref":"jhn_t_tree.html#t:index/0"},{"type":"type","title":"jhn_t_tree.opt/0","doc":null,"ref":"jhn_t_tree.html#t:opt/0"},{"type":"opaque","title":"jhn_t_tree.t_tree/0","doc":null,"ref":"jhn_t_tree.html#t:t_tree/0"},{"type":"type","title":"jhn_t_tree.value/0","doc":null,"ref":"jhn_t_tree.html#t:value/0"},{"type":"module","title":"jhn_timestamp","doc":"A timestamp library based on: Date and Time on the Internet: Timestamps (rfc3339) Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content (rfc7231) The timestamp is represented as follows: posix : integer() stamp : #{year =&gt; integer(), month =&gt; integer(), day =&gt; integer(), hour =&gt; integer(), minute =&gt; integer(), second =&gt; integer(), fraction =&gt; integer(), offset =&gt; Offset } Offset : 'Z' | #{sign =&gt; '+' | '-', hours =&gt; integer(), minutes =&gt; integer()} The fraction and offset parts are optional","ref":"jhn_timestamp.html"},{"type":"function","title":"jhn_timestamp.decode/1","doc":"Decodes the binary or posix integer timestamp into a map representing a timestamp. Equivalent of decode(Binary, [])","ref":"jhn_timestamp.html#decode/1"},{"type":"function","title":"jhn_timestamp.decode/2","doc":"Decodes the binary or posix integer timestamp into a map representing a timestamp. Decode will give an exception if the binary is not well formed timestamp. Options are: seconds (default) -&gt; second precision milli -&gt; milli second precision micro -&gt; micro second precision nano -&gt; nano second precision rfc7231 -&gt; the binary is a rfc7231 compatible continue -&gt; all remaining indata is returned when decoding a binary","ref":"jhn_timestamp.html#decode/2"},{"type":"function","title":"jhn_timestamp.encode/1","doc":"Encodes the map as an iolist. Equivalent of encode(Stamp, [])","ref":"jhn_timestamp.html#encode/1"},{"type":"function","title":"jhn_timestamp.encode/2","doc":"Encodes the Stamp as an iolist or binary. Encode will give an exception if the Stamp is not well formed. Options are: seconds (default) -&gt; second precision (no fraction generated) milli -&gt; milli second precision micro -&gt; micro second precision nano -&gt; nano second precision binary -&gt; a binary is returned list -&gt; a flat list is returned iolist -&gt; an iolist is returned rfc7231 -&gt; the returned string is rfc7231 compatible posix -&gt; a posix integer timestamp is returned","ref":"jhn_timestamp.html#encode/2"},{"type":"function","title":"jhn_timestamp.gen/0","doc":"Generates the timestamp as an iolist of precision seconds Equivalent of gen([])","ref":"jhn_timestamp.html#gen/0"},{"type":"function","title":"jhn_timestamp.gen/1","doc":"Generates a timestamp and encode as an iolist, list, binary, or integer posix timestamp. Options are: seconds (default) -&gt; second precision milli -&gt; milli second precision micro -&gt; micro second precision nano -&gt; nano second precision binary -&gt; a binary is returned list -&gt; a flat list is returned iolist (default) -&gt; an iolist is returned rfc7231 -&gt; the returned string is rfc7231 compatible, and precision is seconds, e.g., posix -&gt; a posix integer timestamp is returned","ref":"jhn_timestamp.html#gen/1"},{"type":"type","title":"jhn_timestamp.opt/0","doc":null,"ref":"jhn_timestamp.html#t:opt/0"},{"type":"type","title":"jhn_timestamp.posix/0","doc":null,"ref":"jhn_timestamp.html#t:posix/0"},{"type":"type","title":"jhn_timestamp.stamp/0","doc":null,"ref":"jhn_timestamp.html#t:stamp/0"},{"type":"module","title":"jhn_uri","doc":"A URI library based on: Uniform Resource Identifier (URI): Generic Syntax (rfc3986)","ref":"jhn_uri.html"},{"type":"function","title":"jhn_uri.decode/1","doc":"Decodes the binary into a structured Erlang term. Equivalent of decode(Binary, []) -&gt; URI.","ref":"jhn_uri.html#decode/1"},{"type":"function","title":"jhn_uri.decode/2","doc":"Decodes the binary into a structured Erlang. Decode will give an exception if the binary is not well formed URI. Options are:","ref":"jhn_uri.html#decode/2"},{"type":"function","title":"jhn_uri.encode/1","doc":"Encodes the structured Erlang term as an iolist. Equivalent of encode(Term, []) -&gt; URI.","ref":"jhn_uri.html#encode/1"},{"type":"function","title":"jhn_uri.encode/2","doc":"Encodes the structured Erlang term as an iolist or binary. Encode will give an exception if the erlang term is not well formed. Options are: binary -&gt; a binary is returned list -&gt; a flat list is returned iolist -&gt; a iolist is returned ipv4 -&gt; an ipv4 address is encoded when the Host is an integer ipv6 -&gt; an ipv6 address is encoded when the Host is an integer ipv6ipv4 -&gt; encoded IPv6 host address has the two least sigificant segments repesented in IPv4 address format compact -&gt; the most compact encoding of IPv6 used (collapsed zeros)","ref":"jhn_uri.html#encode/2"},{"type":"type","title":"jhn_uri.opt/0","doc":null,"ref":"jhn_uri.html#t:opt/0"},{"type":"type","title":"jhn_uri.opts/0","doc":null,"ref":"jhn_uri.html#t:opts/0"},{"type":"type","title":"jhn_uri.scheme/0","doc":null,"ref":"jhn_uri.html#t:scheme/0"},{"type":"type","title":"jhn_uri.uri/0","doc":null,"ref":"jhn_uri.html#t:uri/0"},{"type":"module","title":"jhn_uuid","doc":"A UUID library based on: Universally Unique IDentifiers (UUIDs) (rfc9562) Uniform Resource Names (URNs) (rfc8141) A library for generating UUIDs of all versions defined in rfc9562. Functions for encoding/decoding UUIDs are provided for completness and testing purposes and the select few occations they are actually needed. N.B. Does not support Version 2, no support currently planned. Support for non-standard UUIDs with no dashes are provided using hex option","ref":"jhn_uuid.html"},{"type":"function","title":"jhn_uuid.decode/1","doc":"Decodes the binary into a map representing an UUID. Decode will raise an exception if the binary is not well formed UUID. Equivalent of decode(Binary, []) -&gt; UUID.","ref":"jhn_uuid.html#decode/1"},{"type":"function","title":"jhn_uuid.decode/2","doc":"Decodes the binary into a map representing an UUID. Decode will raise an exception if the binary is not well formed UUID. Options are: human -&gt; a human readable timestamp is generated for types v1, v6 and v7","ref":"jhn_uuid.html#decode/2"},{"type":"function","title":"jhn_uuid.encode/1","doc":"Encodes the map represention of an UUID as an iolist. Equivalent of encode(UUID, [])","ref":"jhn_uuid.html#encode/1"},{"type":"function","title":"jhn_uuid.encode/2","doc":"Encodes the map represention of an UUID or URN as required the options. Encode will give an exception if the UUID is not well formed. Options are: iolist (default) -&gt; an iolist is returned binary -&gt; a binary is returned list -&gt; a flat list is returned hex -&gt; the raw hex format without the dashes (this is outside the spec). urn -&gt; the URN is returned (can be combined with binary, iolist, list)","ref":"jhn_uuid.html#encode/2"},{"type":"function","title":"jhn_uuid.gen/1","doc":"Generates the an UUID as an iolist of Type (type v3, v5 and v8 not applicable) Equivalent of gen(Type, []) -&gt; UUID for applicable types.","ref":"jhn_uuid.html#gen/1"},{"type":"function","title":"jhn_uuid.gen/2","doc":"Generates the an UUID or URN of Type This is normally the only function used. To quote rfc9562 &quot;As general guidance, avoiding parsing UUID values unnecessarily is recommended; instead, treat UUIDs as opaquely as possible&quot;. Types are: v1, v3, v4, v5, v6, v7, v8, nil, max Options are: General format: iolist (default) -&gt; an iolist is returned binary -&gt; a binary is returned list -&gt; a flat list is returned hex -&gt; the raw hex format without the dashes (this is outside the spec). uuid -&gt; a map representing the UUID is generated that can be passed to encode but can differ from the one generated from decode since some information may have been lost. human -&gt; when combined with uuid provides human readable timstamps for v1, v6 and v7 urn -&gt; the URN is returned (can be combined with binary, iolist, list) Type specific options. They are all optional if not marked as required: v1: {node, Node} -&gt; binary MAC, integer or the atoms random and undefined {clock_sequence, CSeq} -&gt; integer v3: {name, Name} (required) -&gt; iodata representing the name {name_space, NameSpace} -&gt; iodata representing namespace or an atom representing one of the predefined namespaces: dns, url, oid, x500, nil and max v5: {name, Name} (required) -&gt; same as for v3 {name_space, NameSpace} -&gt; same as for v3 v6: {node, Node} -&gt; same as for v1 {clock_sequence, CSeq} -&gt; same as for v1 v8: {custom, Custom} (required) -&gt; an integer or 122 bit binary","ref":"jhn_uuid.html#gen/2"},{"type":"type","title":"jhn_uuid.custom_opt/0","doc":null,"ref":"jhn_uuid.html#t:custom_opt/0"},{"type":"type","title":"jhn_uuid.format_opt/0","doc":null,"ref":"jhn_uuid.html#t:format_opt/0"},{"type":"type","title":"jhn_uuid.mac_address/0","doc":null,"ref":"jhn_uuid.html#t:mac_address/0"},{"type":"type","title":"jhn_uuid.name_opt/0","doc":null,"ref":"jhn_uuid.html#t:name_opt/0"},{"type":"type","title":"jhn_uuid.node_type/0","doc":null,"ref":"jhn_uuid.html#t:node_type/0"},{"type":"type","title":"jhn_uuid.opt/0","doc":null,"ref":"jhn_uuid.html#t:opt/0"},{"type":"type","title":"jhn_uuid.opts/0","doc":null,"ref":"jhn_uuid.html#t:opts/0"},{"type":"type","title":"jhn_uuid.posix/0","doc":null,"ref":"jhn_uuid.html#t:posix/0"},{"type":"type","title":"jhn_uuid.type/0","doc":null,"ref":"jhn_uuid.html#t:type/0"},{"type":"type","title":"jhn_uuid.uuid/0","doc":null,"ref":"jhn_uuid.html#t:uuid/0"},{"type":"type","title":"jhn_uuid.v1_opt/0","doc":null,"ref":"jhn_uuid.html#t:v1_opt/0"},{"type":"extras","title":"jhn_stdlib (γ)","doc":"jhn_stdlib [(γ)][5]\n==========\n\nA few thought experiments solidified as code: CBOR, JSON, MessagePack, syslog,\nURI, IP addresses, Timestamps, UUIDs\n\n  * [Introduction](#introduction)\n  * [Behaviours](#behaviours)\n  * [Features/Modules](#features)\n  * [Deprecated Features/Modules](#deprecated)\n  * [Build](#build)\n  * [Install](#install)\n  * [Contribute](#contribute) - Read if you're planning to submit patches\n\n \n\nIntroduction\n------------\n\nThis library consists mainly of code that arose out of my curiosity, either\nabout Erlang and coding in general or concerning a perticular protocol or\ntechnique. So there is little of cohesion in purposes between the different\nlibrary modules. But having published these I will continue to support these\nsince the road to enlightenment is one without terminus.\n\nBehaviours\n--------\n\n  * ```jhn_server``` -- A generic server\n  * ```jhn_fsm``` -- A FSM with the ability to defer acting on events until\n    a later state\n\n \n\nFeatures/Modules\n--------\n\n  * String Processing Functions for binary encoded strings\n    * ```jhn_blist``` -- drop in replacement for the lists module in stdlib\n    * ```jhn_bstring``` -- drop in replacement for the string module in stdlib\n    * ```jhn_mustache``` -- [Mustache (template system)][37]\n  * Protocols\n    * Bencoding -- encoding/decoding -- ```jhn_bencoding```\n    * CBOR -- encoding/decoding -- ```jhn_cbor``` [rfc8949][43], [rfc9542][45]\n    * JSON  -- encoding/decoding -- ```jhn_json``` [rfc8259][30]\n    * JSON Pointer -- encoding/decoding/evaluation -- ```jhn_json``` [rfc6901][8]\n    * JSON Patch -- evaluation -- ```jhn_json``` [rfc6902][31]\n    * JSON Merge Patch  -- evaluation -- ```jhn_json``` [rfc7396][32]\n    * MessagePack -- encoding/decoding -- ```jhn_msgpack``` [MessagePack][12]/Erlang\n    * Syslog -- encoding/decoding  -- ```jhn_syslog``` [rfc5424][13], [rfc5427][14], [rfc6012][29]\n  * Standards\n    * IP Addresses -- encoding/decoding -- ```jhn_ip_addr``` [rfc4291][16], [rfc5952][17], [rfc4632][18]\n    * Timestamps -- generating/encoding/decoding -- ```jhn_timestamp``` [rfc3339][19], [rfc7231][21]\n    * URI -- encoding/decoding -- ```jhn_uri``` [rfc3986][15]\n    * UUID -- generating/encoding/decoding -- ```jhn_uuid``` [rfc9562][42][rfc8144]\n  * Clients\n    * HTTP -- client -- ```jhn_shttpc``` [rfc7230][20], [rfc7231][21], [rfc7538][22], [rfc5789][23], [rfc2818][24]\n    * Syslog -- server/client -- ```jhn_syslog``` [rfc5425][25], [rfc5426][26], [rfc6587][27]\n  * Pull oriented data source abstraction\n    * lazy -- ```jhn_lazy``` abstracts different data sources as uniform lazy data\n  * Data structures\n    * Bloom filters -- ```jhn_bloom``` [Bloom Filters][36]\n    * Property lists -- ```jhn_plist```\n    * Prefix trees -- ```jhn_p_tree``` [Prefix Tree][38]\n    * Binary(UTF-8) Prefix trees -- ```jhn_pb_tree``` [Prefix Tree][38], [UTF-8][39]\n    * Range trees -- ```jhn_r_tree``` [Range Tree][40]\n    * T-trees -- ```jhn_t_tree``` [T-tree][41]\n  * Algorithms\n    * Levenshtein distance -- ```jhn_math:levenshtein/2``` [Levenshtein][35]\n    * CRC32-C checksum -- ```jhn_hash:crc32c/1``` [rfc9260][33]\n    * xxHash-32 checksum -- ```jhn_hash:xxh32/1```, ```jhn_hash:xxh32/2``` [xxHash][34]\n    * Consistent Hashing -- ```jhn_chash:jump/2``` [J. Lamping, Eric Veach][28]\n\n \n\nDeprecated Features/Modules\n--------\n\n \n\nBuild\n-----\n\njhn_stdlib requires [rebar3][1] to build, but provides make support to download\nand install rebar. To build jhn_stdlib, go to the jhn_stdlib directory and type:\n\n```sh\nmake\n```\n\nTo make sure jhn_stdlib works on your platform, run the tests:\n\n```sh\nmake test\n```\n\n \n\nInstall\n-------\n\nIf you want to install your own built version of jhn_stdlib add the ebin\ndirectory to your Erlang code path or move the jhn_stdlib folder into your\nrelease folder and make sure that folder is in your `ERL_LIBS`\nenvironment variable.\n\n\n \n\nContribute\n----------\n\nShould you find yourself using jhn_stdlib and have issues, comments or\nfeedback please [create an issue here on GitHub.] [2]\n\nPatches are greatly appreciated, but since these libraries reflect my\nlearning process and I have rather peculiar notions of code hygiene\nI may do extensive rewrites that does not in any way diminish the\nappreciation I feel or indeed express\n\nFor a much nicer history, please [write good commit messages][4].\nI know I really should.\n\n  [1]: https://github.com/erlang/rebar3 \"Rebar3 - A build tool for Erlang\"\n  [2]: http://github.com/JanHenryNystrom/jhn_stdlib/issues \"jhn_stdlib issues\"\n  [4]: http://github.com/erlang/otp/wiki/Writing-good-commit-messages \"Erlang/OTP commit messages\"\n  [5]: http://en.wikipedia.org/wiki/Software_release_life_cycle \"Software release life cycle\"\n  [6]: http://www.ietf.org/rfc/rfc4627.txt \"The application/json Media Type for JavaScript Object Notation (JSON)\"\n  [7]: http://www.ietf.org/rfc/rfc7159.txt \"The JavaScript Object Notation (JSON) Data Interchange Format\"\n  [8]: http://www.ietf.org/rfc/rfc6901.txt \"JavaScript Object Notation (JSON) Pointer\"\n  [10]: http://tools.ietf.org/id/draft-zyp-json-schema-04.txt \"JSON Schema: core definitions and terminology\"\n  [11]: http://tools.ietf.org/id/draft-fge-json-schema-validation-00.txt \"JSON Schema: interactive and non interactive validation\"\n  [12]: http://msgpack.org/ \"An efficient binary serialization format\"\n  [13]: http://www.ietf.org/rfc/rfc5424.txt \"The Syslog Protocol\"\n  [14]: http://www.ietf.org/rfc/rfc5427.txt \"Textual Conventions for Syslog Management\"\n  [15]: http://www.ietf.org/rfc/rfc3986.txt \"Uniform Resource Identifier (URI): Generic Syntax\"\n  [16]: http://www.ietf.org/rfc/rfc4291.txt \"IP Version 6 Addressing Architecture\"\n  [17]: http://www.ietf.org/rfc/rfc5952.txt \"A Recommendation for IPv6 Address Text Representation\"\n  [18]: http://www.ietf.org/rfc/rfc4632.txt \"Classless Inter-domain Routing (CIDR): The Internet Address Assignment and Aggregation Plan\"\n  [19]: http://www.ietf.org/rfc/rfc3339.txt \"Date and Time on the Internet: Timestamps\"\n  [20]: http://www.ietf.org/rfc/rfc7230.txt \"Hypertext Transfer Protocol (HTTP/1.1): Message Syntax and Routing\"\n  [21]: http://www.ietf.org/rfc/rfc7231.txt \"Hypertext Transfer Protocol (HTTP/1.1): Semantics and Content\"\n  [22]: http://www.ietf.org/rfc/rfc7538.txt \"The Hypertext Transfer Protocol Status Code 308 (Permanent Redirect)\"\n  [23]: http://www.ietf.org/rfc/rfc5789.txt \"PATCH Method for HTTP\"\n  [24]: http://www.ietf.org/rfc/rfc2818.txt \"HTTP Over TLS (rfc2818)\"\n  [25]: http://www.ietf.org/rfc/rfc5425.txt \"Transport Layer Security (TLS) Transport Mapping for Syslog\"\n  [26]: http://www.ietf.org/rfc/rfc5426.txt \"Transmission of Syslog Messages over UDP\"\n  [27]: http://www.ietf.org/rfc/rfc6587.txt \"Transmission of Syslog Messages over TCP\"\n  [28]: https://arxiv.org/ftp/arxiv/papers/1406/1406.2294.pdf \"A Fast, Minimal Memory, Consistent Hash Algorithm, John Lamping, Eric Veach\"\n  [29]: http://www.ietf.org/rfc/rfc6012.txt \"Datagram Transport Layer Security (DTLS) Transport Mapping for Syslog\"\n  [30]: http://www.ietf.org/rfc/rfc8259.txt \"The JavaScript Object Notation (JSON) Data Interchange Format\"\n  [31]: http://www.ietf.org/rfc/rfc6902.txt \"JavaScript Object Notation (JSON) Patch\"\n  [32]: http://www.ietf.org/rfc/rfc7396.txt \"JSON Merge Patch\"\n  [33]: http://www.ietf.org/rfc/rfc9260.txt \"[Castagnoli93] G. Castagnoli, S. Braeuer and M. Herrman \\\"Optimization of Cyclic Redundancy-Check Codes with 24 and 32 Parity Bits\\\", IEEE Transact. on Communications, Vol. 41, No. 6, June 1993.\"\n  [34]: http://github.com/Cyan4973/xxHash \"xxHash - Extremely fast hash algorithm\"\n  [35]: https://en.wikipedia.org/wiki/Levenshtein_distance \"Levenshtein distance\"\n  [36]: https://en.wikipedia.org/wiki/Bloom_filter \"Bloom filter\"\n  [37]: https://en.wikipedia.org/wiki/Mustache_(template_system) \"Mustache (template system)\"\n  [38]: https://en.wikipedia.org/wiki/Trie \"Trie\"\n  [39]: https://en.wikipedia.org/wiki/UTF-8 \"UTF-8\"\n  [40]: https://en.wikipedia.org/wiki/Range_tree \"Range tree\"\n  [41]: https://en.wikipedia.org/wiki/T-tree \"T-tree\"\n  [42]: http://www.ietf.org/rfc/rfc9562.txt \"Universally Unique IDentifiers (UUIDs)\"\n  [43]: http://www.ietf.org/rfc/rfc8949.txt \"Concise Binary Object Representation (CBOR)\"\n  [44]: http://www.ietf.org/rfc/rfc9542.txt \"IANA Considerations and IETF Protocol and Documentation Usage for IEEE 802 Parameters\"\n  [45]: http://www.ietf.org/rfc/rfc8141.txt \"Uniform Resource Names (URNs)\"","ref":"readme.html"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS","ref":"license.html"}],"content_type":"text/plain","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}